//
//  AppDelegate.m
//  Mycroft's Map
//
//  Created by Everett Kaser on 2/20/18.
//  Copyright © 2018 Everett Kaser Software. All rights reserved.
//

#import "kintAppDelegate.h"
#import "kintView.h"
#import "kintMAIN.h"
#import "kintPMACH.h"

kintAppDelegate    *kApp;
bool ProgramReady=false, inSize=false, firstSize=false;
int LaunchCount=0;
//float   KINTvolume=1.0;

//**********************************************************
#if BETA

// change BETA DATE in kintPMACH.h

NSString *betastring=@"This is a TEST program, copyright 2019 Everett Kaser. You must stop using this test version by Sep 15, 2019.";
#endif
//***********************************************************



#if GEEKDEBUG
//*********************************************
void WriteDebug(char *p) {

	FILE *fp=NULL;
	
	BuildPath("debug.log", DIR_GAME, true);
	fp=fopen(TmpPath, "a+");
	if( fp!=NULL ) {
		fwrite(p, strlen(p), 1, fp);
		fwrite("\r\n", 2, 1, fp);
		fclose(fp);
	}
}
#endif

//*********************************************
@implementation kintWindow

-(BOOL)windowShouldClose:(NSWindow *)sender {
	
	while( inKE ) ;
	return ForceMsg(KHDR_QUERY_QUIT, 0, 0, 0) ? YES: NO;
}
-(void)windowWillClose:(NSNotification *)notification {
	NSLog(@"windowWillClose");
}
@end

//*********************************************
@implementation kintAppDelegate

@synthesize window;
//@synthesize viewController;
//@synthesize windowController;

// NOTE: NSRect frame = [[NSScreen mainScreen] visibleFrame]; returns the USEFUL screen area


//*********************************************
-(id)init {
	
    if( self = [super init] ) {
//		Ddel();
//		Dwrite("init 1");
		NSRect contentSize = NSMakeRect(50.0, 0.0, 1000.0, 600.0);
        NSUInteger windowStyleMask = NSWindowStyleMaskTitled | NSWindowStyleMaskResizable | NSWindowStyleMaskClosable | NSWindowStyleMaskMiniaturizable;
        window = [[kintWindow alloc] initWithContentRect:contentSize styleMask:windowStyleMask backing:NSBackingStoreBuffered defer:NO];
        window.backgroundColor = [NSColor whiteColor];
		window.title = (__bridge NSString * _Nonnull)((CFStringRef)CFBundleGetValueForInfoDictionaryKey(CFBundleGetMainBundle(), CFSTR("EKSGameName")));
		//[[NSBundle mainBundle] @"EKSGameName"];
		//[ [ CFBridgingRelease((CFStringRef)CFBundleGetValueForInfoDictionaryKey(CFBundleGetMainBundle(), CFSTR("EKSGameName")));
//		Dwrite("init 2");

		if( @available(macOS 10.10, *) ) {
		} else {
			SystemMessage((char*)"This game requires Mac OS X 10.10.0 or later.");
			exit(1);
		}
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didResizeNotification:) name:NSWindowDidResizeNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didMoveNotification:) name:NSWindowDidMoveNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didMiniaturizeNotification:) name:NSWindowDidMiniaturizeNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didDeminiaturizeNotification:) name:NSWindowDidDeminiaturizeNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didEnterFullScreenNotification:) name:NSWindowDidEnterFullScreenNotification object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(willEnterFullScreenNotification:) name:NSWindowWillEnterFullScreenNotification object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(willExitFullScreenNotification:) name:NSWindowWillExitFullScreenNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didExitFullScreenNotification:) name:NSWindowDidExitFullScreenNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(willStartLiveResizeNotification:) name:NSWindowWillStartLiveResizeNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didEndLiveResizeNotification:) name:NSWindowDidEndLiveResizeNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didFrameChangeNotification:) name:NSViewFrameDidChangeNotification object:nil];
	}
//	Dwrite("init 3");
	return self;
}

//*********************************************
bool inFrameChange=false, isFullScreen, isHidden=false;
WORD LastFrameChangeW=0, LastFrameChangeH=0;

//********************************************************
-(void)didFrameChangeNotification : NSNotification {

	WORD	w=0, h=0;
    
//    Dwrite("didFrameChangeNotification");
    if( !inFrameChange && !inSetTitle ) {
        inFrameChange = true;
        
        Boolean	goingFullScreen = (!isFullScreen && ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen);
/*
        if( NSThread.currentThread.isMainThread )
        {
            char dBuf[128];
            sprintf(dBuf,"didFrameChangeNotification m kA=%d,%d pKV=%d iFC=%d iST=%d",kApp==nil?0:1,[kApp window]==nil?0:1,pKV==nil?0:1, inFrameChange?1:0, inSetTitle?1:0);
            Dwrite(dBuf);
        } else Dwrite("didFrameChangeNotification n");
*/
        if( kApp!=nil && [kApp window]!=nil ) {
            if( goingFullScreen || (isFullScreen && ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen) == NSWindowStyleMaskFullScreen) ) {
                NSRect sr=[[NSScreen mainScreen] frame];
                w = SWPvw = sr.size.width;
                h = SWPvh = sr.size.height;
            } else  if( pKV!= nil ) {
                w = (WORD)[pKV frame].size.width;
                h = (WORD)[pKV frame].size.height;
            }
            if( pKV!=nil ) {
        //NSLog(@"didFrameChangeNotification START");
                if( kBM[0].orient & BMO_90 ) {
                    kBM[0].logW = h;
                    kBM[0].logH = w;
                } else {
                    kBM[0].logW = w;
                    kBM[0].logH = h;
                }
  /*              {
                    char dBuf[128];
                    sprintf(dBuf,"didFrameChangeNotification 1 ISW=%d wW=%d hH=%d (%d,%d)",InSetWindowPos, w==LastFrameChangeW, h==LastFrameChangeH, w, h);
                    Dwrite(dBuf);
                }
*/
                if( !InSetWindowPos && (w!=LastFrameChangeW || h!=LastFrameChangeH) ) {
                    LastFrameChangeW = w;
                    LastFrameChangeH = h;
            //		NSLog(@"didFrameChangeNotification (%d,%d)", kBM[0].logW, kBM[0].logH);
            #if GEEKDEBUG
                    char sbuf[128];
                    sprintf(sbuf,"didFrameChangeNotification (%d,%d)", kBM[0].logW, kBM[0].logH);
                    WriteDebug(sbuf);
            #endif
//                    Dwrite("didFrameChangeNotification 2");
                    if( kBM[0].physW!=0 && (kBM[0].logW > kBM[0].physW || kBM[0].logH > kBM[0].physH) ) InitScreen(kBM[0].logW, kBM[0].logH);
//                    Dwrite("didFrameChangeNotification 3");
                    if( ProgramReady ) {
            //NSLog(@"dFCN adding WINDOW_SIZE");
                        DWORD	p, didit=0;

                        SWPvw = kBM[0].logW;
                        SWPvh = kBM[0].logH;
                        
                        p = KINTmsgrem;
                        while( p != KINTmsgadd ) {
                            if( KINTmsgs[p*4]==KHDR_WINDOW_SIZE ) {	// if found, modify it
                                KINTmsgs[p*4+1] = kBM[0].logW;
                                KINTmsgs[p*4+2] = kBM[0].logH;
                                didit = 1;
                                break;
                            } else ++p;	// keep searching
                            if( p==MAXMSGS ) p = 0;
                        }
//                        Dwrite("didFrameChangeNotification 4");
                        if( !didit ) {
                            AddMsg(KHDR_WINDOW_SIZE, kBM[0].logW, kBM[0].logH, K_SIZED);
                            //NSLog(@"dFCN SendNextMsg");
                            SendNextMsg();
                        }
            //NSLog(@"dFCN SendNextMsg");
                        SendNextMsg();
            //NSLog(@"dFCN while");
//                        Dwrite("didFrameChangeNotification 5");

            #if GEEKDEBUG
                        WriteDebug("InvDirty");
            #endif
            //			NSLog(@"dFCN InvDirty");
                        InvDirty();
            #if GEEKDEBUG
                        WriteDebug("done");
            #endif
                    }
                }
            }
            isFullScreen = (([[kApp window] styleMask] & NSWindowStyleMaskFullScreen) == NSWindowStyleMaskFullScreen);
        }
//        Dwrite("didFrameChangeNotification 6");
        inFrameChange = false;
    }
}

//********************************************************
-(void)willStartLiveResizeNotification : NSNotification {
	inSize = true;
//	NSLog(@"willStartLiveResizeNotification");
}

//********************************************************
-(void)didEndLiveResizeNotification : NSNotification {
	inSize = false;
//	NSLog(@"didEndLiveResizeNotification");
}

//********************************************************
-(void)didResizeNotification : NSNotification {

	DWORD	w, h;
	
//    if( NSThread.currentThread.isMainThread ) Dwrite("didResizeNotification 1 m");
//    else Dwrite("didResizeNotification 1");
        w = [pKV frame].size.width;
        h = [pKV frame].size.height;
        kBM[0].logW = w;
        kBM[0].logH = h;
        SWPvw = w;
        SWPvh = h;
    isFullScreen = ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen;
        if( ProgramReady /*windowReady*/ && !InSetWindowPos && !inSize ) {
    //		NSLog(@"didResizeNotification(%d,%d)", w, h);
    #if GEEKDEBUG
            char sbuf[128];
            sprintf(sbuf,"didResizeNotification (%d,%d)", w, h);
            WriteDebug(sbuf);
    #endif
            // search msg queue and if find another KHDR_WINDOW_SIZE waiting, just modify it's W/H values
            DWORD	p;
            
            p = KINTmsgrem;
            while( p != KINTmsgadd ) {
                if( KINTmsgs[p*4]==KHDR_WINDOW_SIZE ) {	// if found, modify it
                    KINTmsgs[p*4+1] = w;
                    KINTmsgs[p*4+2] = h;
                    return;
                } else ++p;	// keep searching
                if( p==MAXMSGS ) p = 0;
            }
            AddMsg(KHDR_WINDOW_SIZE, w, h, K_SIZED);
            SetSWPv();
        }
//	Dwrite("didResizeNotification 2");
}
//********************************************************
-(void)didMoveNotification : NSNotification {
	
	DWORD	x, y, w, h;
//NSLog(@"didMoveNotification");
//    if( NSThread.currentThread.isMainThread ) Dwrite("didMoveNotification 1 m");
//    else Dwrite("didMoveNotification 1");
    isFullScreen = ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen;
    x = [[kApp window].contentView frame].origin.x;
    y = [[kApp window].contentView frame].origin.y;
    w = [[kApp window].contentView frame].size.width;
    h = [[kApp window].contentView frame].size.height;
	if( pKV!=nil && ProgramReady/* windowReady*/ ) {
//        Dwrite("didMoveNotification add");
		x = (DWORD)[pKV frame].origin.x;
		y = (DWORD)[pKV frame].origin.y;
		AddMsg(KHDR_WINDOW_MOVE, x, y, 0);
	}
//    Dwrite("didMoveNotification 2");
}
//********************************************************
-(void)didMiniaturizeNotification : NSNotification {
	
//    if( windowReady ) {
    isFullScreen = ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen;
        isHidden = true;
        AddMsg(KHDR_WINDOW_HIDDEN, 1, 0, 0);
//    }
}

//********************************************************
-(void)didDeminiaturizeNotification : NSNotification {
	
//    if( windowReady ) {
    isFullScreen = ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen;
        isHidden = false;
        AddMsg(KHDR_WINDOW_HIDDEN, 0, 0, 0);
//    }
}

//********************************************************
-(void)willEnterFullScreenNotification : NSNotification {
    
//    NORMblock = 1;
//    KINT_GetWindowPos(&NORMx, &NORMy, &NORMw, &NORMh, &NORMo);
//NSLog(@"ExitFULL RESTORED (%d,%d)(%d,%d)",SWPx,SWPy,SWPvw,SWPvh);
}

//********************************************************
-(void)didEnterFullScreenNotification : NSNotification {
	
#if GEEKDEBUG
	WriteDebug("didEnterFulScreenNotification");
#endif
//    if( windowReady ) {
    isFullScreen = ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen;
        if( isFullScreen ) {
            NSRect sr=[[NSScreen mainScreen] frame];
            SWPvw = sr.size.width;
            SWPvh = sr.size.height;
        } else {
            SWPvw = [pKV frame].size.width;
            SWPvh = [pKV frame].size.height;
        }
        AddMsg(KHDR_WINDOW_SIZE, SWPvw, SWPvh, K_MAXIMIZED);
//    }
}
//********************************************************
-(void)willExitFullScreenNotification : NSNotification {
    
}

//********************************************************
-(void)didExitFullScreenNotification : NSNotification {
    
//    if( windowReady ) {
    isFullScreen = ([[kApp window] styleMask] & NSWindowStyleMaskFullScreen)==NSWindowStyleMaskFullScreen;
        if( [pKV frame].size.width<20 ) {
            DWORD	w;
            
            w = 15*PhysicalScreenH/100;
            NSRect	rect = NSMakeRect((CGFloat)w, (CGFloat)w, (CGFloat)(PhysicalScreenW-2*w), (CGFloat)(PhysicalScreenH-2*w));
            [[kApp window] setFrame:rect display:YES];
        }
        SWPvw = [pKV frame].size.width;
        SWPvh = [pKV frame].size.height;
        AddMsg(KHDR_WINDOW_SIZE, SWPvw, SWPvh, K_RESTORED);
//    }
}

//********************************************************
-(void)applicationWillFinishLaunching:(NSNotification *)notification
{
//	Dwrite("applicationWillFinishLaunching 1");
//	view = [[kintView alloc] initWithFrame:CGRectMake(0, 0, 700, 700)];
//    [window setContentView:view];           // Hook the view up to the window
}

//********************************************************
-(void)applicationDidFinishLaunching:(NSNotification *)notification
{
//    if( NSThread.currentThread.isMainThread ) Dwrite("applicationDidFinishLaunching 1 m");
//    else Dwrite("applicationDidFinishLaunching 1");
//NSLog(@"application didFinishLaunching");
    kApp = self;
	// Override point for customization after application launch.

#if BETA
	NSAlert	*alert = [[NSAlert alloc] init];
	[alert addButtonWithTitle: @"Yes, I agree"];
	[alert addButtonWithTitle: @"No, I don't agree"];
	[alert setMessageText:betastring];
	[alert setAlertStyle: NSWarningAlertStyle];
	NSModalResponse resp = [alert runModal];
	if( resp!=NSAlertFirstButtonReturn ) exit(1);
	KGetTime(&betatime);
	if( betatime.y > BETA_YEAR || (betatime.y==BETA_YEAR && (betatime.mo > BETA_MONTH || (betatime.mo==BETA_MONTH && betatime.d >= BETA_DAY))) ) {
		SystemMessage("The BETA TEST period for this program has elapsed. Please replace it with the official demo or licensed version. Visit our web page: www.kaser.com.");
		exit(1);
	}
#endif
	
	SetAppDataPath();

//	Dwrite("applicationDidFinishLaunching 2");
#if GEEKDEBUG
	WriteDebug("***************** KINT LOADING ****************");
#endif
	if( !LoadKEFile() ) exit(1);
//	Dwrite("applicationDidFinishLaunching 3");
#if GEEKDEBUG
	WriteDebug("***************** Past LoadKEFile ****************");
#endif
	++KEloaded;

	// Create a view
	view = [[kintView alloc] initWithFrame:CGRectMake(0, 0, 700, 700)];
//	Dwrite("applicationDidFinishLaunching 4");
#if GEEKDEBUG
	WriteDebug("***************** initWithFrame ****************");
#endif
	[window setContentView:view];

//	Dwrite("applicationDidFinishLaunching 5");
	SysStartup();
//	Dwrite("applicationDidFinishLaunching 6");

	InitScreen(0,0);
//	Dwrite("applicationDidFinishLaunching 7");

	++KEloaded;
//    [window orderOut:nil];
	[window makeKeyAndOrderFront:nil];     // Show the window
    
    
    
/*
    NSRect windowBounds = [[kApp window] frame];
    {
        char dBuf[128];
        sprintf(dBuf,"KINT_GetWindowPos: %d,%d,%d,%d", (int)windowBounds.origin.x, (int)windowBounds.origin.y, (int)windowBounds.size.width, (int)windowBounds.size.height);
        Dwrite(dBuf);
    }
*/
    
    
    
    
    windowReady = true;
//	Dwrite("applicationDidFinishLaunching 8");

	ForceMsg(KHDR_BEGIN_STARTUP, 0, 0, 0);
//	Dwrite("applicationDidFinishLaunching 9");
//    ++LaunchCount;
//    Dwrite("applicationDidFinishLaunching 9.5");
//NSLog(@"OnEndStartup");
	ForceMsg(KHDR_END_STARTUP, 0, 0, 0);
//	Dwrite("applicationDidFinishLaunching 10");

	ProgramReady = true;
#if GEEKDEBUG
    char sbuf[128];
    sprintf(sbuf,"WND SIZE: (%d,%d)x(%d,%d)", SWPx,SWPy, SWPw,SWPh);
    WriteDebug(sbuf);
#endif
	AddMsg(KHDR_WINDOW_SIZE, SWPw, SWPh, K_SIZED);
//    Dwrite("applicationDidFinishLaunching 11");
	AddMsg(KHDR_WINDOW_MOVE, SWPx, SWPy, 0);
//	Dwrite("applicationDidFinishLaunching 12");
//	KINT_SetWindowPos();
//NSLog(@"IDLE");
	AddMsg(KHDR_IDLE, 0, 0, 0);
	firstSize = true;
	kBM[0].logW = SWPw;
	kBM[0].logH = SWPh;
//    NSLog(@"application didFinishLaunchingWithOptions RETURN");
//	Dwrite("applicationDidFinishLaunching 13");
}

//********************************************************
-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender {
	return TRUE;
}
-(void)applicationWillUnhide:(NSNotification *)notification {
	
}
-(void)applicationDidUnhide:(NSNotification *)notification {
	
//not being called on minimized	AddMsg(KHDR_WINDOW_HIDDEN, 0, 0, 0);
}
-(void)applicationWillHide:(NSNotification *)notification {
	
}
-(void)applicationDidHide:(NSNotification *)notification {
	
// not being called on minimize	AddMsg(KHDR_WINDOW_HIDDEN, 1, 0, 0);
}
-(void)applicationWillUpdate:(NSNotification *)notification {
    
}
-(void)applicationDidUpdate:(NSNotification *)notification {
	
}
-(void)applicationWillBecomeActive:(NSNotification *)notification {
	
	if( KeyFlags & MK_CTL ) {	// MK_CTL means the CMD key was down, as in CMD-Tab was used to switch AWAY
		KeyFlags &= ~MK_CTL;
		AddMsg(KHDR_KEY_UP, VK_CONTROL, 0, 0);
	}
}
-(void)applicationDidBecomeActive:(NSNotification *)notification {
	
}
-(void)applicationDidChangeScreenParameters:(NSNotification *)notification {
	
#if GEEKDEBUG
	WriteDebug("applicationDidChangeScreenParameters");
#endif
	
}

//********************************************************
-(NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {
	while( inKE ) ;
	return ForceMsg(KHDR_QUERY_QUIT, 0, 0, 0) ? YES: NO;
}
//********************************************************
- (void)applicationWillTerminate:(NSApplication *)application
{
    //    NSLog(@"applicationWillTerminate");
	StopMusic();
	[[NSNotificationCenter defaultCenter] removeObserver:self];
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    SysExit();
}
@end
