#import "kintMAIN.h"
#import "kintPMACH.h"

union KFunion {
  KFf4 flt;
  struct {
    unsigned frac : 23;
    unsigned exp : 8;
    unsigned sign : 1;
  } bits;
};

#define KCLZ(S,N) {(S)=0; for(KFu4 m=0x80000000; !((N)&m) && (S)<32; m>>=1, ++(S));}

///********************************************
KFf4 KFadd(KFf4 a, KFf4 b) {

	KFs4 A_s;
	KFs4 A_e;
	KFu4 A_f;
	KFs4 B_s;
	KFs4 B_e;
	KFu4 B_f;
	KFs4 R_s;
	KFs4 R_e;
	KFu4 R_f;
	KFf4 r;
	int ediff, diff;

	union KFunion KFraw;

	KFraw.flt = a;
	A_f = KFraw.bits.frac;
	A_e = KFraw.bits.exp;
	A_s = KFraw.bits.sign;
	A_f <<= (3);

	KFraw.flt = b;
	B_f = KFraw.bits.frac;
	B_e = KFraw.bits.exp;
	B_s = KFraw.bits.sign;
	B_f <<= (3);

	if( A_s == B_s ) {
		R_s = A_s;
		ediff = A_e - B_e;
		if( ediff > 0 ) {
			R_e = A_e;
			if( B_e == 0 ) {
				if( B_f == 0 ) {
					R_f = A_f;
					goto add_done;
				} else {
					ediff--;
					if( ediff == 0) {
						R_f = A_f + B_f;
						goto add3;
					}
					if( A_e == 255 ) {
						R_f = A_f;
						goto add_done;
					}
					goto add1;
				}
			} else if( A_e == 255 ) {
				R_f = A_f;
				goto add_done;
			}
			B_f |= ((KFu4) 1 << (24 -1+3));
add1:
			if( ediff <= (3 + 24) ) B_f = (B_f >> ediff);
			else if( B_f != 0 ) B_f = 1;
            R_f = A_f + B_f;
		} else if( ediff < 0 ) {
			ediff = -ediff;
			R_e = B_e;
			if( A_e == 0 ) {
				if( A_f == 0 ) {
					R_f = B_f;
					goto add_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = B_f + A_f;
						goto add3;
					}
					if( B_e == 255 ) {
						R_f = B_f;
						goto add_done;
					}
					goto add2;
				}
			} else if( B_e == 255 ) {
				R_f = B_f;
				goto add_done;
			}
			A_f |= ((KFu4) 1 << (24 -1+3));
add2:
			if( ediff <= (3 + 24) ) A_f = (A_f >> ediff);
			else if ( A_f != 0 ) A_f = 1;
			R_f = B_f + A_f;
		} else {
			if( !(((A_e + 1) & 255) > 1) ) {
				if( A_e == 0 ) {
					R_e = 0;
					if( A_f == 0 ) {
						R_f = B_f;
						goto add_done;
					} else if( B_f == 0 ) {
						R_f = A_f;
						goto add_done;
					} else {
						R_f = A_f + B_f;
						if( R_f & ((KFu4) 1 << (24 -1+3)) ) {
							R_f &= ~(KFu4) ((KFu4) 1 << (24 -1+3));
							R_e = 1;
						}
						goto add_done;
					}
				} else {
					R_e = 255;
					if( A_f == 0 ) R_f = B_f;
					else if( B_f == 0 ) R_f = A_f;
					else {
						A_f >>= 3;
						B_f >>= 3;
						if( (A_f & ((KFu4) 1 << (24 -2))) && !(B_f & ((KFu4) 1 << (24 -2))) ) {
							R_s = B_s;
							R_f = B_f;
						} else {
							R_s = A_s;
							R_f = A_f;
						}
						R_f <<= (3);
					}
					goto add_done;
				}
			}
			R_f = A_f + B_f;
			R_e = A_e + 1;
			R_f = (R_f >> 1) | (R_f & 1);
			if( R_e == 255 ) R_f = 0;
			goto add_done;
		}
add3:
		if( R_f & ((KFu4) 1 << (24 -1+3)) ) {
			R_f &= ~(KFu4) ((KFu4) 1 << (24 -1+3));
			R_e++;
			R_f = (R_f >> 1 | (R_f & 1));
			if( R_e == 255 ) R_f = 0;
		}
add_done:
	 ;
	} else {
		ediff = A_e - B_e;
		if( ediff > 0 ) {
			R_e = A_e;
			R_s = A_s;
			if( B_e == 0 ) {
				if( B_f == 0 ) {
					R_f = A_f;
					goto sub_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = A_f - B_f;
						goto sub3;
					}
					if( A_e == 255 ) {
						R_f = A_f;
						goto sub_done;
					}
					goto sub1;
				}
			} else if( A_e == 255 ) {
				R_f = A_f;
				goto sub_done;
			}
			B_f |= ((KFu4) 1 << (24 -1+3));
sub1:
			if( ediff <= (3 + 24) ) B_f = (B_f >> ediff | ((B_f << (32 - ediff)) != 0));
			else if( B_f != 0 ) B_f = 1;
			R_f = A_f - B_f;
		} else if( ediff < 0 ) {
			ediff = -ediff;
			R_e = B_e;
			R_s = B_s;
			if( A_e == 0 ) {
				if( A_f == 0 ) {
					R_f = B_f;
					goto sub_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = B_f - A_f;
						goto sub3;
					}
					if( B_e == 255 ) {
						R_f = B_f;
						goto sub_done;
					}
					goto sub2;
				}
			} else if( B_e == 255 ) {
				R_f = B_f;
				goto sub_done;
			}
			A_f |= ((KFu4) 1 << (24 -1+3));
sub2:
			if( ediff <= (3 + 24) ) (A_f = (A_f >> ediff | ((A_f << (32 - ((ediff)))) != 0)));
			else if( A_f != 0 ) A_f = 1;
			R_f = B_f - A_f;
		} else {
			if( !(((A_e + 1) & 255) > 1) ) {
				if( A_e == 0 ) {
					R_e = 0;
					if( A_f == 0 ) {
						R_f = B_f;
						if( B_f == 0 ) R_s = 0;
						else R_s = B_s;
						goto sub_done;
					} else if( B_f == 0 ) {
						R_f = A_f;
						R_s = A_s;
						goto sub_done;
					} else {
						R_f = A_f - B_f;
						R_s = A_s;
						if( R_f & ((KFu4) 1 << (24 -1+3)) ) {
							R_f = B_f - A_f;
							R_s = B_s;
						} else if( R_f == 0 ) R_s = 0;
						goto sub_done;
					}
				} else {
					R_e = 255;
					if( A_f == 0 ) {
						if( B_f == 0 ) {
							R_s = 0;
							R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
							R_f <<= 3;
						} else {
							R_s = B_s;
							R_f = B_f;
						}
					} else {
						if( B_f == 0 ) {
							R_s = A_s;
							R_f = A_f;
						} else {
							A_f >>= 3;
							B_f >>= 3;
							if( (A_f & ((KFu4) 1 << (24 -2))) && !((B_f) & ((KFu4) 1 << (24 -2)))) {
								R_s = B_s;
								R_f = B_f;
							} else {
								R_s = A_s;
								R_f = A_f;
							}
							R_f <<= (3);
						}
					}
					goto sub_done;
				}
			}
			R_e = A_e;
			R_f = A_f - B_f;
			R_s = A_s;
			if( R_f & ((KFu4) 1 << (24 -1+3))) {
				R_f = B_f - A_f;
				R_s = B_s;
			} else if( R_f == 0 ) {
				R_e = 0;
				R_s = 0;
				goto sub_done;
			}
			goto norm;
		}
sub3:
		if( R_f & ((KFu4) 1 << (24 -1+3)) ) {
			R_f &= ((KFu4) 1 << (24 -1+3)) - 1;
norm:
			if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(diff,R_f)
			else SystemMessage("so(ul)!=so(ui)");

			diff -= (32 - (3 + 24));
			R_f <<= diff;
			if( R_e <= diff ) {
				diff = diff - R_e + 1;
				R_f = (R_f >> diff | ((R_f << (32 - diff)) != 0));
				R_e = 0;
			} else {
				R_e -= diff;
				R_f &= ~(KFu4) ((KFu4) 1 << (24 -1+3));
			}
		}
sub_done:
	;
	}

	if( R_f & 7 ) {
		if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
	}
	if( R_f & (((KFu4) 1 << ((3 + 24))) >> 1)) {
		R_f &= ~(((KFu4) 1 << ((3 + 24))) >> 1);
		R_e++;
		if( R_e == 255 ) R_f = 0;
	}
	R_f >>= 3;
	if( R_e == 255 && R_f != 0 ) R_f |= ((KFu4) 1 << (24 -2));

	union KFunion KFpacked;

	KFpacked.bits.frac = R_f;
	KFpacked.bits.exp = R_e;
   	KFpacked.bits.sign = R_s;
   	r = KFpacked.flt;

  return r;
}

///********************************************
KFf4 KFsub(KFf4 a, KFf4 b) {

	KFs4 A_s;
	KFs4 A_e;
	KFu4 A_f;
	KFs4 B_s;
	KFs4 B_e;
	KFu4 B_f;
	KFs4 R_s;
	KFs4 R_e;
	KFu4 R_f;
	KFf4 r;
	int ediff, diff;

	union KFunion KFraw;

	KFraw.flt = a;
	A_f = KFraw.bits.frac;
	A_e = KFraw.bits.exp;
	A_s = KFraw.bits.sign;
	A_f <<= (3);

	KFraw.flt = b;
	B_f = KFraw.bits.frac;
	B_e = KFraw.bits.exp;
	B_s = KFraw.bits.sign;
	B_f <<= (3);

	if( !(B_e == 255 && !(B_f == 0)) ) B_s ^= 1;
	if( A_s == B_s ) {
		R_s = A_s;
		ediff = A_e - B_e;
		if( ediff > 0 ) {
			R_e = A_e;
			if( B_e == 0 ) {
				if( B_f == 0 ) {
					R_f = A_f;
					goto add_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = A_f + B_f;
						goto add3;
					}
					if( A_e == 255 ) {
						R_f = A_f;
						goto add_done;
					}
					goto add1;
				}
			} else if( A_e == 255 ) {
				R_f = A_f;
				goto add_done;
			}
			B_f |= ((KFu4) 1 << (24 -1+3));
add1:
			if( ediff <= (3 + 24) ) (B_f = (B_f >> ((ediff)) | ((B_f << (32 - ((ediff)))) != 0)));
			else if( B_f != 0 ) B_f = 1;
			R_f = A_f + B_f;
		} else if( ediff < 0 ) {
			ediff = -ediff;
			R_e = B_e;
			if( A_e == 0 ) {
				if( A_f == 0 ) {
					R_f = B_f;
					goto add_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = B_f + A_f;
						goto add3;
					}
					if( B_e == 255 ) {
						R_f = B_f;
						goto add_done;
					}
					goto add2;
				}
			} else if( B_e == 255 ) {
				R_f = B_f;
				goto add_done;
			}
			A_f |= ((KFu4) 1 << (24 -1+3));
add2:
			if( ediff <= (3 + 24) ) A_f = (A_f >> ((ediff)) | ((A_f << (32 - ((ediff)))) != 0));
			else if( A_f != 0 ) A_f = 1;
			R_f = B_f + A_f;
		} else {
			if( !(((A_e + 1) & 255) > 1) ) {
				if( A_e == 0 ) {
					R_e = 0;
					if( A_f == 0 ) {
						R_f = B_f;
						goto add_done;
					} else if( B_f == 0 ) {
						R_f = A_f;
						goto add_done;
					} else {
						R_f = A_f + B_f;
						if( R_f & ((KFu4) 1 << (24 -1+3)) ) {
							R_f &= ~(KFu4) ((KFu4) 1 << (24 -1+3));
							R_e = 1;
						}
						goto add_done;
					}
				} else {
					R_e = 255;
					if( A_f == 0 ) R_f = B_f;
					else if( B_f == 0 ) R_f = A_f;
					else {
						A_f >>= 3;
						B_f >>= 3;
						if( (A_f & ((KFu4) 1 << (24 -2))) && !(B_f & ((KFu4) 1 << (24 -2))) ) {
							R_s = B_s;
							R_f = B_f;
						} else {
							R_s = A_s;
							R_f = A_f;
						}
						R_f <<= 3;
					}
					goto add_done;
				}
			}
			R_f = A_f + B_f;
			R_e = A_e + 1;
			R_f = (R_f >> ((1)) | (R_f & 1));
			if (R_e == 255) R_f = 0;
			goto add_done;
		}
add3:
		if( R_f & ((KFu4) 1 << (24 -1+3))) {
			R_f &= ~(KFu4) ((KFu4) 1 << (24 -1+3));
			R_e++;
			R_f = (R_f >> ((1)) | (R_f & 1));
			if( R_e == 255 ) R_f = 0;
		}
add_done:
	;
	} else {
		ediff = A_e - B_e;
		if( ediff > 0 ) {
			R_e = A_e;
			R_s = A_s;
			if( B_e == 0 ) {
				if( B_f == 0 ) {
					R_f = A_f;
					goto sub_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = A_f - B_f;
						goto sub3;
					}
					if( A_e == 255 ) {
						R_f = A_f;
						goto sub_done;
					}
					goto sub1;
				}
			} else if( A_e == 255 ) {
				R_f = A_f;
				goto sub_done;
			}
			B_f |= ((KFu4) 1 << (24 -1+3));
sub1:
			if( ediff <= (3 + 24)) (B_f = (B_f >> ((ediff)) | ((B_f << (32 - ((ediff)))) != 0)));
			else if( B_f != 0 ) B_f = 1;
			R_f = A_f - B_f;
		} else if( ediff < 0) {
			ediff = -ediff;
			R_e = B_e;
			R_s = B_s;
			if( A_e == 0 ) {
				if( A_f == 0 ) {
					R_f = B_f;
					goto sub_done;
				} else {
					ediff--;
					if( ediff == 0 ) {
						R_f = B_f - A_f;
						goto sub3;
					}
					if( B_e == 255 ) {
						R_f = B_f;
						goto sub_done;
					}
					goto sub2;
				}
			} else if( B_e == 255 ) {
				R_f = B_f;
				goto sub_done;
			}
			A_f |= ((KFu4) 1 << (24 -1+3));
sub2:
			if( ediff <= (3 + 24) ) (A_f = (A_f >> ((ediff)) | ((A_f << (32 - ((ediff)))) != 0)));
			else if( A_f != 0 ) A_f = 1;
			R_f = B_f - A_f;
		} else {
			if( !(((A_e + 1) & 255) > 1) ) {
				if( A_e == 0 ) {
					R_e = 0;
					if( A_f == 0 ) {
						R_f = B_f;
						if( B_f == 0 ) R_s = (0 == 3);
						else R_s = B_s;
						goto sub_done;
					} else if( B_f == 0 ) {
						R_f = A_f;
						R_s = A_s;
						goto sub_done;
					} else {
						R_f = A_f - B_f;
						R_s = A_s;
						if( R_f & ((KFu4) 1 << (24 -1+3)) ) {
							R_f = B_f - A_f;
							R_s = B_s;
						} else if( R_f == 0 ) R_s = 0;
						goto sub_done;
					}
				} else {
					R_e = 255;
					if( A_f == 0 ) {
						if( B_f == 0 ) {
							R_s = 0;
							R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
							R_f <<= (3);
						} else {
							R_s = B_s;
							R_f = B_f;
						}
					} else {
						if( B_f == 0 ) {
							R_s = A_s;
							R_f = A_f;
						} else {
							A_f >>= 3;
							B_f >>= 3;
							if( (A_f & ((KFu4) 1 << (24 -2))) && !((B_f) & ((KFu4) 1 << (24 -2)))) {
								R_s = B_s;
								R_f = B_f;
							} else {
								R_s = A_s;
								R_f = A_f;
							}
							R_f <<= (3);
						}
					}
					goto sub_done;
				}
			}
			R_e = A_e;
			R_f = A_f - B_f;
			R_s = A_s;
			if( R_f & ((KFu4) 1 << (24 -1+3))) {
				R_f = B_f - A_f;
				R_s = B_s;
			} else if( R_f == 0 ) {
				R_e = 0;
				R_s = 0;
				goto sub_done;
			}
			goto norm;
		}
sub3:
		if( R_f & ((KFu4) 1 << (24 -1+3))) {
			R_f &= ((KFu4) 1 << (24 -1+3)) - 1;
norm:
			if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(diff,R_f)
			else SystemMessage("so(ul)!=so(ui)");
//			if( sizeof (KFu4) == sizeof (unsigned int) ) diff = __builtin_clz (R_f);
//			else diff = __builtin_clzl (R_f);

			diff -= (32 - (3 + 24));
			R_f <<= (diff);
			if( R_e <= diff ) {
				diff = diff - R_e + 1;
				R_f = (R_f >> diff | ((R_f << (32 - ((diff)))) != 0));
				R_e = 0;
			} else {
				R_e -= diff;
				R_f &= ~(KFu4) ((KFu4) 1 << (24 -1+3));
			}
		}
sub_done:
	 ;
	}

	if( R_f & 7) {
		if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
	}
	if( R_f & (((KFu4) 1 << ((3 + 24))) >> 1)) {
		R_f &= ~(((KFu4) 1 << ((3 + 24))) >> 1);
		R_e++;
		if( R_e == 255 ) {
			R_e = 255;
			R_f = 0;
		}
	}
	R_f >>= 3;
	if( R_e == 255 && R_f != 0 ) {
		R_f |= ((KFu4) 1 << (24 -2));
	}

	union KFunion KFpacked;

	KFpacked.bits.frac = R_f;
	KFpacked.bits.exp = R_e;
	KFpacked.bits.sign = R_s;
	r = KFpacked.flt;
	return r;
}

///********************************************
KFf4 KFmul(KFf4 a, KFf4 b) {

	KFs4 A_s;
	KFs4 A_e;
	KFu4 A_f;
	KFs4 B_s;
	KFs4 B_e;
	KFu4 B_f;
	KFs4 R_s;
	KFs4 R_e;
    KFu4 R_f=0;
	KFf4 r;

	KFs4	A_c;
	KFs4	B_c;
	KFs4	R_c=0;

	KFs4 shift;
	KFu4 f0 , f1;

	union KFunion KFraw;

	KFraw.flt = a;
	A_f = KFraw.bits.frac;
	A_e = KFraw.bits.exp;
	A_s = KFraw.bits.sign;

	switch( A_e ) {
	 default:
		(A_f) |= ((KFu4) 1 << (24 -1));
		A_f <<= (3);
		A_e -= 127;
		A_c = 0;
		break;
	 case 0:
		if( A_f == 0 ) A_c = 1;

		if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(shift,A_f)
		else SystemMessage("so(ul)!=so(ui)");

		shift -= (32 - 24);
		A_f <<= (shift + 3);
		A_e -= (127 - 1 + shift);
		A_c = 0;
		break;
	 case 255:
		if( A_f == 0 ) A_c = 2;
		else A_c = 3;
		break;
	}

	KFraw.flt = b;
	B_f = KFraw.bits.frac;
	B_e = KFraw.bits.exp;
	B_s = KFraw.bits.sign;
	switch( B_e ) {
	 default:
		B_f |= ((KFu4) 1 << (24 -1));
		B_f <<= (3);
		B_e -= 127;
		B_c = 0;
		break;
	 case 0:
	 	if( B_f == 0 ) B_c = 1;

		if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(shift,B_f)
		else SystemMessage("so(ul)!=so(ui)");

		shift -= (32 - 24);
		B_f <<= (shift + 3);
		B_e -= (127 - 1 + shift);
		B_c = 0;
		break;
	 case 255:
	 	if( B_f == 0 ) B_c = 2;
	 	else B_c = 3;
		break;
	}
	R_s = A_s ^ B_s;
	R_e = A_e + B_e + 1;
	switch( (A_c << 2) | B_c ) {
	 case 0:
		R_c = 0;
/*
		__asm__ ("mul{l} %3"
			: "=a" ((USItype) (f0)), "=d" ((USItype) (f1))
			: "%0" ((USItype) (A_f)), "rm" ((USItype) (B_f)));

The above assembles to:
			mov A_f,%eax
			mull B_f
			mov %eax,f0
			mov %edx,f1
which the next 4 lines are an attempt at replacing with C code.
*/
		KFs8	mpc;	// "long long" is 64-bit signed integer
		mpc = (KFs8)B_f * (KFs8)A_f;
		f0 = (KFs4)(mpc & 0x0FFFFFFFF);
		f1 = (KFs4)((mpc>>32) & 0x0FFFFFFFF);

            (void)(((((3 + 24))-1) < /* DISABLES CODE */ (32))
			? (
				{
					f0 =
						(f1 << (32 - (((3 + 24))-1)) | f0 >> (((3 + 24))-1) | ((f0 << (32 - (((3 + 24))-1))) != 0));
					f1 >>= (((3 + 24))-1);
				}
			  )
			: (
				{
					f0 =
						(f1 >> ((((3 + 24))-1) - 32) | ((((f1 << (2*32 - (((3 + 24))-1)))) | f0) != 0));
					f1 = 0;
				}
			  )
		);
		R_f = f0;
		if( (R_f & ((KFu4) 1 << ((3 + 24)))) ) R_f = (R_f >> ((1)) | (R_f & 1));
		else R_e--;
		break;
	 case 15:
		if( (A_f & ((KFu4) 1 << (24 -2))) && !((B_f) & ((KFu4) 1 << (24 -2))) ) {
			R_s = B_s;
			R_f = B_f;
		} else {
			R_s = A_s;
			R_f = A_f;
		}
		R_c = 3;
		break;
	 case 12:
	 case 14:
	 case 13:
	 	R_s = A_s;
	 case 10:
	 case 8:
	 case 4:
	 case 5:
	 	R_f = A_f;
	 	R_c = A_c;
	 	break;
	 case 3:
	 case 11:
	 case 7:
	 	R_s = B_s;
	 case 2:
	 case 1:
	 	R_f = B_f;
	 	R_c = B_c;
	 	break;
	 case 9:
	 case 6:
	 	R_s = 0;
	 	R_c = 3;
	 	R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
	 	break;
	}

	switch( R_c ) {
	 case 0:
	 	R_e += 127;
		if( R_e > 0 ) {
			if( R_f & 7 ) {
				if( ((R_f) & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
			}
			if( R_f & ((KFu4) 1 << ((3 + 24))) ) {
				R_f &= ~((KFu4) 1 << ((3 + 24)));
				R_e++;
			}
			R_f >>= 3;
			if( R_e >= 255 ) {
				R_c = 2;
				R_e = 255;
				R_f = 0;
			}
		} else {
			R_e = -R_e + 1;
			if( R_e <= (3 + 24) ) {
				R_f = (R_f >> ((R_e)) | ((R_f << (32 - ((R_e)))) != 0));
				if( R_f & 7 ) {
					if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
				}
				if( R_f & (((KFu4) 1 << ((3 + 24))) >> 1) ) {
					R_e = 1;
					R_f = 0;
				} else {
					R_e = 0;
					R_f >>= 3;
				}
			} else {
				R_e = 0;
				if( R_f != 0 ) {
					R_f = 1;
					if( R_f & 7 ) {
						if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
						R_f >>= (3);
					}
				}
			}
		}
		break;
	 case 1:
		R_e = 0;
		R_f = 0;
		break;
	 case 2:
		R_e = 255;
		R_f = 0;
		break;
	 case 3:
		R_e = 255;
		R_f |= ((KFu4) 1 << (24 -2));
		break;
	}
	union KFunion KFpacked;

	KFpacked.bits.frac = R_f;
	KFpacked.bits.exp = R_e;
	KFpacked.bits.sign = R_s;
	r = KFpacked.flt;

	return r;
}

///********************************************
KFf4 KFdiv(KFf4 a, KFf4 b) {

	KFs4 A_s;
	KFs4 A_e;
	KFu4 A_f;
	KFs4 B_s;
	KFs4 B_e;
	KFu4 B_f;
	KFs4 R_s;
	KFs4 R_e;
	KFu4 R_f=0;
	KFf4 r;

	KFs4	A_c;
	KFs4	B_c;
	KFs4	R_c=0;

	KFs4 shift;
	int loop_count, loop_msb;
	KFu4 loop_u_f, loop_v_f;

	union KFunion KFraw;

	KFraw.flt = a;
	A_f = KFraw.bits.frac;
	A_e = KFraw.bits.exp;
	A_s = KFraw.bits.sign;

	switch( A_e ) {
	 default:
		(A_f) |= ((KFu4) 1 << (24 -1));
		A_f <<= (3);
		A_e -= 127;
		A_c = 0;
		break;
	 case 0:
		if( A_f == 0 ) A_c = 1;

		if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(shift,A_f)
		else SystemMessage("so(ul)!=so(ui)");

		shift -= (32 - 24);
		A_f <<= (shift + 3);
		A_e -= (127 - 1 + shift);
		A_c = 0;
		break;
	 case 255:
		if( A_f == 0 ) A_c = 2;
		else A_c = 3;
		break;
	}

	KFraw.flt = b;
	B_f = KFraw.bits.frac;
	B_e = KFraw.bits.exp;
	B_s = KFraw.bits.sign;
	switch( B_e ) {
	 default:
		B_f |= ((KFu4) 1 << (24 -1));
		B_f <<= (3);
		B_e -= 127;
		B_c = 0;
		break;
	 case 0:
	 	if( B_f == 0 ) B_c = 1;

		if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(shift,B_f)
		else SystemMessage("so(ul)!=so(ui)");

		shift -= (32 - 24);
		B_f <<= (shift + 3);
		B_e -= (127 - 1 + shift);
		B_c = 0;
		break;
	 case 255:
	 	if( B_f == 0 ) B_c = 2;
	 	else B_c = 3;
		break;
	}

	R_s = A_s ^ B_s;
	R_e = A_e - B_e;
	switch( (((A_c) << 2) | (B_c)) ) {
	 case 0:
	 	R_c = 0;
		loop_count = (3 + 24);

		loop_u_f = A_f;
		loop_v_f = B_f;
		R_f = 0;
		loop_u_f <<= ((32 - (3 + 24)));
		loop_v_f <<= ((32 - (3 + 24)));
		if( (loop_u_f >= loop_v_f) ) {
			loop_u_f = loop_u_f - loop_v_f;
			R_f |= 1;
			loop_count--;
		} else R_e--;
		do {
			loop_msb = (KFs4) (loop_u_f) < 0;
			loop_u_f += loop_u_f;
			R_f += R_f;
			if( loop_msb || (loop_u_f >= loop_v_f) ) {
				loop_u_f = loop_u_f - loop_v_f;
				R_f |= 1;
			}
		} while (--loop_count > 0);
		R_f |= !(loop_u_f == 0);
		break;
	 case 15:
		if( (A_f & ((KFu4) 1 << (24 -2))) && !(B_f & ((KFu4) 1 << (24 -2))) ) {
			R_s = B_s;
			R_f = B_f;
		} else {
			R_s = A_s;
			R_f = A_f;
		}
		R_c = 3;
		break;
	 case 12:
	 case 14:
	 case 13:
	 	R_s = A_s;
	 	R_f = A_f;
	 	R_c = A_c;
	 	break;
	 case 3:
	 case 11:
	 case 7:
	 	R_s = B_s;
	 	R_f = B_f;
	 	R_c = B_c;
	 	break;
	 case 2:
	 case 6:
	 case 4:
	 	R_c = 1;
	 	break;
	 case 1:
	 case 9:
	 case 8:
	 	R_c = 2;
	 	break;
	 case 10:
	 case 5:
	 	R_s = 0;
	 	R_c = 3;
	 	R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
	 	break;
	}

	switch( R_c ) {
	 case 0:
	 	R_e += 127;
	 	if( R_e > 0 ) {
			if( R_f & 7 ) {
				if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
			}
			if( (R_f & ((KFu4) 1 << ((3 + 24)))) ) {
				R_f &= ~((KFu4) 1 << ((3 + 24)));
				R_e++;
			}
			R_f >>= 3;
			if( R_e >= 255 ) {
			 	R_c = 2;
				if( R_c == 2 ) {
					R_e = 255;
					R_f = 0;
				} else {
					R_e = 255 - 1;
					R_f = (~(KFs4) 0);
				}
			}
		} else {
			R_e = -R_e + 1;
			if( R_e <= (3 + 24) ) {
				R_f = (R_f >> ((R_e)) | ((R_f << (32 - ((R_e)))) != 0));
				if( R_f & 7) {
					if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
				}
				if( R_f & (((KFu4) 1 << ((3 + 24))) >> 1) ) {
					R_e = 1;
					R_f = 0;
				} else {
					R_e = 0;
					R_f >>= 3;
				}
			} else {
				R_e = 0;
				if(  R_f != 0 ) {
					R_f = 1;
					if( R_f & 7 ) {
						if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
					}
					R_f >>= (3);
				}
			}
		}
		break;
	 case 1:
	 	R_e = 0;
	 	R_f = 0;
	 	break;
	 case 2:
	 	R_e = 255;
	 	R_f = 0;
	 	break;
	 case 3:
	 	R_e = 255;
/*	 	if( !1 ) {
			R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
			R_s = 0;
		} else {
*/
            R_f |= ((KFu4) 1 << (24 -2));
//		}
		break;
	}
	union KFunion KFpacked;

	KFpacked.bits.frac = R_f;
	KFpacked.bits.exp = R_e;
	KFpacked.bits.sign = R_s;
	r = KFpacked.flt;

	return r;
}

///********************************************
KFf4 KFneg(KFf4 a) {

	KFs4	A_s;
	KFs4	A_e;
	KFu4	A_f;
	KFs4	R_s;
	KFs4	R_e;
	KFu4	R_f;
	KFf4 r;

	union KFunion KFraw;

	KFraw.flt = a;
	A_f = KFraw.bits.frac;
	A_e = KFraw.bits.exp;
	A_s = KFraw.bits.sign;

	R_f = A_f;
	R_e = A_e;
	R_s = 1 ^ A_s;

	union KFunion KFpacked;

	KFpacked.bits.frac = R_f;
	KFpacked.bits.exp = R_e;
	KFpacked.bits.sign = R_s;
	r = KFpacked.flt;

	return r;
}

///********************************************
KFf4 KFsqr(KFf4 a) {

	KFs4	A_c;
	KFs4	A_s;
	KFs4	A_e;
	KFu4	A_f;
	KFs4	R_c=0;
	KFs4	R_s=0;
	KFs4	R_e=0;
	KFu4	R_f=0;
	KFf4 r;

	KFs4 shift;
	KFu4	T_f, S_f, q;

	union KFunion KFraw;

	KFraw.flt = a;
	A_f = KFraw.bits.frac;
	A_e = KFraw.bits.exp;
	A_s = KFraw.bits.sign;

	switch( A_e ) {
	 default:
	 	A_f |= ((KFu4) 1 << (24 -1));
		A_f <<= 3;
		A_e -= 127;
		A_c = 0;
		break;
	 case 0:
	 	if( A_f == 0 ) A_c = 1;
		else {
			if( sizeof(KFu4) == sizeof (unsigned int) ) KCLZ(shift,A_f)
			else SystemMessage("so(ul)!=so(ui)");

			shift -= (32 - 24);
			A_f <<= (shift + 3);
			A_e -= (127 - 1 + shift);
			A_c = 0;
		}
		break;
	 case 255:
	 	if( A_f == 0 ) A_c = 2;
	 	else A_c = 3;
		break;
	}

	switch( A_c ) {
	 case 3:
	 	R_f = A_f;
	 	R_s = A_s;
	 	R_c = 3;
	 	break;
	 case 2:
	 	if( A_s ) {
			R_s = 0;
			R_c = 3;
			R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
		} else {
			R_s = 0;
			R_c = 2;
		}
		break;
	 case 1:
	 	R_s = A_s;
	 	R_c = 1;
	 	break;
	 case 0:
	 	R_s = 0;
	 	if( A_s ) {
			R_c = 3;
			R_s = 0;
			R_f = ((((KFu4) 1 << (24 -2)) << 1) - 1);
			break;
		}
		R_c = 0;
		if( A_e & 1 ) A_f += A_f;
		R_e = A_e >> 1;
		S_f = 0;
		R_f = 0;
		q = ((KFu4) 1 << ((3 + 24))) >> 1;
		while( q != ((KFu4) 1 << 2) ) {
			T_f = S_f + q;
			if( T_f <= A_f ) {
				S_f = T_f + q;
				A_f -= T_f;
				R_f += q;
			}
			A_f += A_f;
			q >>= 1;
		}
		if( A_f ) {
			if( S_f < A_f ) R_f |= ((KFu4) 1 << 2);
			R_f |= ((KFu4) 1 << 0);
		}
	}

	switch( R_c ) {
	 case 0:
	 	R_e += 127;
		if( R_e > 0 ) {
			if( R_f & 7 ) {
				if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
			}
			if( (R_f & ((KFu4) 1 << ((3 + 24)))) ) {
				R_f &= ~((KFu4) 1 << ((3 + 24)));
				R_e++;
			}
			R_f >>= 3;
			if( R_e >= 255 ) {
				R_c = 2;
				if( R_c == 2 ) {
					R_e = 255;
					R_f = 0;
				} else {
					R_e = 255 - 1;
					R_f = (~(KFs4) 0);
				}
			}
		} else {
			R_e = -R_e + 1;
			if( R_e <= (3 + 24) ) {
				R_f = (R_f >> ((R_e)) | ((R_f << (32 - ((R_e)))) != 0));
				if( R_f & 7) {
					if( (R_f & 15) != ((KFu4) 1 << 2)) R_f += ((KFu4) 1 << 2);
				}
				if( R_f & (((KFu4) 1 << ((3 + 24))) >> 1) ) {
					R_e = 1;
					R_f = 0;
				} else {
					R_e = 0;
					R_f >>= 3;
				}
			} else {
				R_e = 0;
				if( R_f != 0 ) {
					R_f = 1;
					if( R_f & 7 ) {
						if( (R_f & 15) != ((KFu4) 1 << 2) ) R_f += ((KFu4) 1 << 2);
					}
					R_f >>= (3);
				}
			}
		}
		break;
	 case 1:
	 	R_e = 0;
	 	R_f = 0;
	 	break;
	 case 2:
	 	R_e = 255;
	 	R_f = 0;
	 	break;
	 case 3:
	 	R_e = 255;
		R_f |= ((KFu4) 1 << (24 -2));
		break;
	}
	union KFunion KFpacked;

	KFpacked.bits.frac = R_f;
	KFpacked.bits.exp = R_e;
	KFpacked.bits.sign = R_s;
	r = KFpacked.flt;

	return r;
}


