//
//  main.m
//  Mycroft's Map
//
//  Created by Everett Kaser on 2/20/18.
//  Copyright © 2018 Everett Kaser Software. All rights reserved.
//



/*

 1.0m1 FIXES:
   1) Crash caused by ExecKE being called before startup code had completed.
      Changed KEloaded from BOOL to LONG so it could reflect several different
      steps in the start-up phase, allowing some code to avoid running until
      everything was ready, while allowing other code to run part-way there.
   2) Mouse movement problems, caused by race conditions between adding/editing
      mouse-moved messages in the KEmsgs[] queue while the ExecKE thread was
      removing them.  Changes in mousemoved, mouseddragged, etc, and SendNextMsg.
 
   Both of these only showed up on a few systems, primarily ones with additional
   CPU cores and/or faster speeds.
*/






#import <Cocoa/Cocoa.h>
#import "kintAppDelegate.h"

#import <AVFoundation/AVFoundation.h>
#import <Foundation/Foundation.h>
#import <CoreFoundation/CoreFoundation.h>
#import <Carbon/Carbon.h>
//#import <AudioToolbox/AudioToolbox.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

#import "kintMAIN.h"
#import "kintPMACH.h"
#import "kintView.h"

//****************************

 #include <math.h>
 #include <sys/time.h>
 // *********************************************************************************
/*
 void Dwrite(char *str) {
 
 NSString *targetName;
 NSString *docDir;
 NSArray *paths;
 FILE    *Dfile;
 
 paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
 docDir = [paths objectAtIndex:0];
 targetName = [NSString stringWithFormat:@"%@/%@", docDir, @"Debug"];
 Dfile = fopen([targetName cStringUsingEncoding:1], "a");
 //fseek(Dfile, 0, SEEK_END);
 fwrite((void *)str, 1, strlen(str), Dfile);
 fwrite((void *)"\r\n", 1, 2, Dfile);
 fclose(Dfile);
 }
void Ddel() {
	NSString *targetName;
	NSString *docDir;
	NSArray *paths;
	
	paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	docDir = [paths objectAtIndex:0];
	targetName = [NSString stringWithFormat:@"%@/%@", docDir, @"Debug"];
	unlink([targetName cStringUsingEncoding:1]);
}
*/

int main(int argc, const char * argv[]) {

    NSArray*tl;
    NSApplication *application = [NSApplication sharedApplication];
    [[NSBundle mainBundle] loadNibNamed:@"MainMenu" owner:application topLevelObjects:&tl];
//	Dwrite("main");
//    kintAppDelegate *applicationDelegate = [[kintAppDelegate alloc] init];
//    [application setDelegate:applicationDelegate];
    [application run];
   // return NSApplicationMain(argc, argv);
    return 0;
}

//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************

long	KEloaded=0;

struct	stat	fstats;
//FindFileList	*FirstNextList=NULL;
struct firstnext {
	struct firstnext *pNext;
	BOOL AppData;
	BYTE attrib;
	BYTE fname[3];	// [3] just rounds us up to a DWORD, the MALLOC will add the actual strlen(fname) to the sizeof(FIRSTNEXT)
};
typedef struct firstnext FIRSTNEXT;
FIRSTNEXT *pFirstNext=NULL, *pNextNext=NULL;

#define MAXFILES 16
long	filesCnt=0;
FILE *files[MAXFILES];
//FindFileList	*FirstNextList=NULL;

BOOL InSetWindowPos=FALSE;

//**********************************************************************
void FlushScreen(void) {

//	dispatch_async( dispatch_get_main_queue(), ^{
/*	inSleep = true;
	InvDirty();
	usleep(20000);
	inSleep = false;
*/
//	});
	//	HIWindowFlush ((HIWindowRef) gMacWindow);
}

char BPname[PATHLEN];

void BuildPath(char *pMem, BYTE inFolderType, BOOL AppData) {
	
	char	*p;
	bool	noExt = inFolderType & DIR_NOEXT;
	bool	isJpg = inFolderType & DIR_LOSSY;
	
	// Replace all "\" with "/" in the incoming path
	strcpy(BPname, pMem);
	for(p=BPname; *p; p++) if( *p=='\\' ) *p = '/';
	
	if( AppData ) strcpy(TmpPath, AppDataPath);
	else strcpy(TmpPath, PgmPath);
	
	switch (inFolderType & 0x0f) {
		case DIR_GAME:
			strcat(TmpPath, BPname);
			break;
		case DIR_UI:
			strcat(TmpPath, "UI/");
			strcat(TmpPath, BPname);
			if( !noExt ) {
				if (isJpg) strcat(TmpPath, ".jpg");
				else strcat(TmpPath, ".bmp");
			}
			break;
		case DIR_IMAGES:
			strcat(TmpPath, "IMAGES/");
			strcat(TmpPath, BPname);
			if (!noExt) {
				if (isJpg) strcat(TmpPath, ".jpg");
				else strcat(TmpPath, ".bmp");
			}
			break;
		case DIR_BACKGNDS:
			strcat(TmpPath, "Backgnds/");
			strcat(TmpPath, BPname);
			if( !noExt ) {
				if (isJpg) strcat(TmpPath, ".jpg");
				else strcat(TmpPath, ".bmp");
			}
			break;
		case DIR_MUSIC:
			strcat(TmpPath, "Music/");
			strcat(TmpPath, BPname);
			if( !noExt ) strcat(TmpPath, ".mid");
			break;
		case DIR_SOUNDS:
			strcat(TmpPath, BPname);
			if( !noExt ) strcat(TmpPath, ".wav");
			break;
		case DIR_GAME_IMG:
			strcat(TmpPath, BPname);
			if( !noExt ) {
				if (isJpg) strcat(TmpPath, ".jpg");
				else strcat(TmpPath, ".bmp");
			}
			break;
		case DIR_UI_COMMON:
			strcat(TmpPath, "CommonUI/");
			strcat(TmpPath, BPname);
			if( !noExt ) {
				if (isJpg) strcat(TmpPath, ".jpg");
				else strcat(TmpPath, ".bmp");
			}
			break;
		default:
			break;
	}
}

//*********************************************************************************
// make a sub-folder of the DIR_GAME folder or a sub-folder thereof
// return non-zero if successful, else return zero if fail
int KMakeFolder(char *fname)
{
	int result;
	char	*s, *d;
	
#if _DEBUG && DEBUG_FILE
	printf ("KMakeFolder: %s\n", fname);
#endif
	s = fname;
	d = (char*)"../COMMONUI";
	for(; *s; s++, d++) if( toupper(*s) != *d ) break;
	
	if( !*s ) {
		strcpy(TmpPath, AppDataPath);
		strcat(TmpPath, "CommonUI");
	} else BuildPath(fname, DIR_GAME, TRUE);
	
	result = mkdir(TmpPath, 0777);
	
	// If the path already exists, don't return an error
	if( result != 0 && errno == EEXIST ) result = 0;
	
	return result;
}

//*********************************************************************************
// Delete an empty folder (can NOT contain ANY files)
void KDelFolder(char *fname) {
	
#if _DEBUG && DEBUG_FILE
	//	MacNotImplemented();
	printf ("KDelFolder: %s\n", fname);
#endif
	
	BuildPath(fname, DIR_GAME, TRUE);
	rmdir(TmpPath);
}

//*********************************************************************************
// return file handle if successful, else -1
DWORD Kopen(char *fname, int oflags, BYTE dir) {
	
	// if O_WRBIN or O_WRBINNEW
	// if open(O_RDBIN) in AppData
	// close file
	// else if open(O_RDBIN) in PgmPath
	// close file
	// build AppData filename and copy to tmpbuf
	// KCopyFile(fname, tmpbuf);
	// open(oflags) in AppData
	// return handle
	// else
	// if open(O_RDBIN) in AppData
	// return handle
	// else if open(O_RDBIN) in PgmData
	// return handle
	// return -1
	
	char	*p, tmpbuf[PATHLEN];
	FILE	*fp;
	char	mode[8];
	
	switch (oflags) {
		case O_WRBIN:
			strcpy(mode, "r+b");
			break;
		case O_WRBINNEW:
			strcpy(mode, "w+b");
			break;
		case O_RDBIN:
		default:
			strcpy(mode, "rb");
			break;
	}
	
	if( oflags==O_RDBIN ) {	// if just READING
		BuildPath(fname, dir, TRUE);	// try AppData first
		fp = fopen(TmpPath, mode);
		if( fp==NULL ) {
			BuildPath(fname, dir, FALSE);	// try PgmPath second
			fp = fopen(TmpPath, mode);
		}
	} else {				// if WRITING
		BuildPath(fname, dir, TRUE);	// try AppData first
		strcpy(tmpbuf, TmpPath);		// save AppData target name
		fp = fopen(tmpbuf, "rb");
		if( fp==NULL ) {
			// make sure target AppData path exists
			for(p=tmpbuf+strlen(tmpbuf)-1; p>tmpbuf && *p!='/'; p--) ;	// find end of 'path' portion
			if( p > tmpbuf ) {
				char	*b[64];
				long	bcnt;
				//				mode_t	process_mask;
				
				bcnt = 0;
				b[bcnt] = p;
				*b[bcnt] = 0;	// cut off file name portion, just keep path portion
				++bcnt;
				while( -1==stat(tmpbuf, &fstats) ) {	// find 'lowest' portion of path that already exists
					for(b[bcnt]=b[bcnt-1]-1; b[bcnt]>tmpbuf && *b[bcnt]!='/'; --b[bcnt]) ;	// find next higher folder
					if( b[bcnt] <= tmpbuf ) break;
					*b[bcnt] = 0;
					++bcnt;
				}
				if( b[bcnt-1] > tmpbuf ) {
					while( bcnt>1 ) {			// create the rest of the path folders that didn't already exist
						--bcnt;
						*b[bcnt] = '/';
						//						process_mask = umask(0);
						mkdir(tmpbuf, 0777);
						//						umask(process_mask);
					}
				}
				*b[0] = '/';
			}
			BuildPath(fname, dir, FALSE);	// try PgmPath second
			fp = fopen(TmpPath, "rb");
			if( fp != NULL ) {
				fclose(fp);
				KCopyFile(fname, tmpbuf);
			}
		} else fclose(fp);
#if GEEKDEBUG
//		if( !strcmp(tmpbuf+strlen(tmpbuf)-9, "debug.log") ) strcpy(debfile, tmpbuf);
#endif
		fp = fopen(tmpbuf, mode);
	}
	if( fp==NULL ) return (DWORD)-1;
	files[filesCnt] = fp;
	return (DWORD)filesCnt++;
}

//********************************************************************************
// return file length if successful, else -1
DWORD Kstat(char *fname, BYTE dir, DWORD *modtim, BYTE *filtyp) {
	
	FILE	*fp;
	DWORD	len;
	
	BuildPath(fname, dir, TRUE);	// try AppData first
	if( -1==stat(TmpPath, &fstats) ) {
		BuildPath(fname, dir, FALSE);
		if( -1==stat(TmpPath, &fstats) ) return 0xFFFFFFFF;
	}
	*modtim = (DWORD)fstats.st_mtime;
	if( (fstats.st_mode & S_IFMT)==S_IFDIR ) *filtyp = 2;
	else *filtyp = 1;
	
	fp = fopen(TmpPath, "rb");
	if( fp==NULL ) return 0xFFFFFFFF;
	
	fseek(fp, 0, SEEK_END);
	len = (DWORD)ftell(fp);
	fclose(fp);
	
	return len;
}

//********************************************************************************
// In KINT/KASM, 'origin' has these values (in case your language is different):
//		SEEK_SET    0
//		SEEK_CUR    1
//		SEEK_END    2
// return new file pointer position or -1 if error
DWORD Kseek(DWORD fhandle, DWORD foffset, int origin)
{
	DWORD retVal = -1;
	FILE	*fp;
	
	if( fhandle==(DWORD)-1 || fhandle>=filesCnt  ) goto badHandle;
	fp = files[fhandle];
	
	if( 0!=fseek(fp, foffset, origin) ) goto cantSeek;
	
	retVal = (DWORD)ftell (fp);
	
#if _DEBUG && DEBUG_FILE
	printf("Kseek %08x offset: %d, origin: %02x retval: %08x\n", fhandle, foffset, origin, retVal);
#endif
	
badHandle:
cantSeek:
	return retVal;
}

//*********************************************************************************
void Kclose(DWORD fhandle)
{
#if _DEBUG && DEBUG_FILE
	printf("Kclose %08x\n", fhandle);
#endif
	if( fhandle>=filesCnt || fhandle==0xFFFFFFFF ) goto badHandle;
	
	fclose(files[fhandle]);
	files[fhandle] = NULL;
	
	while( filesCnt && files[filesCnt-1]==NULL ) --filesCnt;
	
badHandle:
	return;
}

//********************************************************************************
//	return 1 if at EOF, 0 if not at EOF, -1 if error
DWORD Keof(DWORD fhandle)
{
	DWORD retVal = -1;
	if( fhandle==0xFFFFFFFF || fhandle>=filesCnt ) goto badHandle;
	retVal = feof(files[fhandle]);
	if( retVal ) retVal = 1;
	
#if _DEBUG && DEBUG_FILE
	printf("Keof %08x, %d\n", fhandle, retVal);
#endif
	
badHandle:
	return retVal;
}

//******************************************************
DWORD Kread(DWORD fhandle, BYTE *pMem, DWORD numbytes)
{
	DWORD retVal = 0;
	
	if( fhandle==0xFFFFFFFF || fhandle>=filesCnt || pMem==NULL ) goto badHandle;
	if( !feof(files[fhandle]) ) retVal = (DWORD)fread(pMem, 1, numbytes, files[fhandle]);
	else retVal = 0;
#if _DEBUG && DEBUG_FILE
	printf("Kread %08x, numbytes: %d, result: %d\n", fhandle, numbytes, retVal);
#endif
	
badHandle:
	return retVal;
}

//*******************************************************
DWORD Kwrite(DWORD fhandle, BYTE *pMem, DWORD numbytes)
{
	DWORD retVal = 0;
	
	if( fhandle==0xFFFFFFFF || fhandle>=filesCnt || pMem==NULL ) goto badHandle;
	
	retVal = (DWORD)fwrite (pMem, 1, numbytes, files[fhandle]);
	
#if _DEBUG && DEBUG_FILE
	printf("Kwrite %08x, numbytes: %d, result: %d\n", fhandle, numbytes, retVal);
#endif
	
badHandle:
	return retVal;
}

//*************************************************


//NOTE: Windows deletes the file from BOTH the PGM and DATA folders, but the MAC KINT only deletes from the DATA folder.

void Kdelete(char *fname, BYTE dir)
{
#if _DEBUG && DEBUG_FILE
	printf ("Kdelete: %s\n", fname);
#endif
	
	if( fname==NULL ) goto badFileName;
	BuildPath (fname, dir, TRUE);
	unlink(TmpPath);
badFileName:
	return;
}

//*******************************************************************
void FixCSVdates(void) {
	
	DWORD	hFile, dw, modtim;
	BYTE	attr, filtyp, appdata;
	char	fname[260], *pFile, *pF, *pXFile, *pX, *p;
	long	y, m, d, t, corrected;
	
	corrected = 0;
	if( 0xFFFFFFFF!=Kfindfirst((char*)"*.csv", (BYTE*)fname, &attr, &appdata, DIR_GAME) ) {
		do {
			BuildPath(fname, DIR_GAME, TRUE);	// try AppData first
			for(p=TmpPath; *p; p++) if( *p=='/' ) *p = '\\';	// DOS/Windows path conversion
			if( -1!=stat(TmpPath, &fstats) ) {
				dw = Kstat(fname, DIR_GAME, &modtim, &filtyp);
				if( 0xFFFFFFFF!=dw ) {
					if( NULL!=(pFile=(char*)malloc(dw+1)) ) {
						if( 0xFFFFFFFF!=(hFile=Kopen(fname, O_WRBIN, DIR_GAME)) ) {
							if( dw==Kread(hFile, (BYTE*)pFile, dw) ) {
								pFile[dw] = 0;
								// allocate reformat buffer
								if( NULL!=(pXFile=(char*)malloc(2*dw)) ) {
									pX = pXFile;
									// skip first line (header)
									for(pF=pFile; *pF && *pF!='\r' && *pF!='\n'; ) *pX++ = *pF++;
									while( *pF=='\r' || *pF=='\n' ) *pX++ = *pF++;
									// process each line of file
									while( *pF ) {
										// get 1st #
										y = atol(pF);
										while( *pF && *pF!='-' ) ++pF;	// skip #
										if( *pF ) ++pF;	// skip -
										// get 2nd #
										m = atol(pF);
										while( *pF && *pF!='-' ) ++pF;	// skip #
										if( *pF ) ++pF;	// skip -
										// get 3rd #
										d = atol(pF);
										while( *pF && isdigit(*pF) ) ++pF;	// skip #
										// swap month and year if month > year (reversed date)
										if( d > y ) {
											t = y;
											y = d;
											d = t;
											t = m;
											m = d;
											d = t;
											corrected = 1;
										}
										// format out date in proper form
										sprintf(pX, "%4.4d-%2.2d-%2.2d", (int)y, (int)m, (int)d);
										pX += strlen(pX);
										while( *pF && *pF!='\r' && *pF!='\n' ) *pX++ = *pF++;
										while( *pF=='\r' || *pF=='\n' ) *pX++ = *pF++;
									}
									if( corrected ) {
										Kseek(hFile, 0, SEEK_SET);
										Kwrite(hFile, (BYTE*)pXFile, (DWORD)(pX-pXFile));
									}
									free(pXFile);
								}
							}
							Kclose(hFile);
						}
						free(pFile);
					}
				}
			}
		} while( 0xFFFFFFFF!=Kfindnext((BYTE*)fname, &attr, &appdata) );
		Kfindclose();
	}
}

//*****************************************************
WORD KCopyFile(char *src, char *dst)
{
#if _DEBUG && DEBUG_FILE
	MacNotImplemented();
	printf ("KCopyFile: %s to %s\n", src, dst);
#endif
	return FALSE;
}

//*****************************************************
void KGetTime(KTIME *pT)
{
	NSDate *now = [NSDate date];
	NSCalendar *sysCalendar = [NSCalendar currentCalendar];
	NSDateComponents *conversionInfo = [sysCalendar components:(NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay ) fromDate:now];
//	CFTimeZoneRef timeZone = CFTimeZoneCopyDefault();
//	CFGregorianDate curtime = CFAbsoluteTimeGetGregorianDate(CFAbsoluteTimeGetCurrent(), timeZone);
	
//	if (timeZone) 	CFRelease(timeZone);
	
	pT->y = [conversionInfo year];
	pT->mo= [conversionInfo month];
	pT->d = [conversionInfo day];
	pT->h = [conversionInfo hour];
	pT->mi= [conversionInfo minute];
	pT->s = [conversionInfo second];
}

//******************************************************
void KTimeToString(BYTE *pMem)
{
	NSDate *now = [NSDate date];
	NSCalendar *sysCalendar = [NSCalendar currentCalendar];
	NSDateComponents *conversionInfo = [sysCalendar components:(NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay ) fromDate:now];
	//	CFTimeZoneRef timeZone = CFTimeZoneCopyDefault();
	//	CFGregorianDate curtime = CFAbsoluteTimeGetGregorianDate(CFAbsoluteTimeGetCurrent(), timeZone);
	
	//	if (timeZone) 	CFRelease(timeZone);
	
	sprintf((char *)pMem, "%4.4u-%2.2u-%2.2u %2.2u:%2.2u:%2.2u", (unsigned int)[conversionInfo year], (unsigned int)[conversionInfo month], (unsigned int)[conversionInfo day], (unsigned int)[conversionInfo hour], (unsigned int)[conversionInfo minute], (unsigned int)[conversionInfo second]);
}

//****************************************************************************
//		Return a millisecond count which doesn't necessarily bear
//		any resemblance to "real" time, but rather is a counter that is
//		a reasonably accurate "millisecond counter" that may eventually
//		roll over to 0, but which should not do so more often than once a day,
//		and who's count value continues upwards (until such time as a roll-over
//		might occur).  This is accomplished on the MS-Windows platform using
//		the GetTickCount() function.  Other platforms may choose to implement
//		this in whatever way seems easiest, while meeting the above criteria.
//		This counter value is only used for timing the speed of animations
//		and brief delays in actions.  So, reasonable accuracy down to 5 or 10
//		milliseconds would be very nice, and the roll-over (if and when it
//		occurs) should only cause (at most) a slight burp in any animation
//		or screen action that is going on at the moment (but from which it
//		should recover almost immediately).
//    NOTE: It is IMPORTANT that his count be relative accurate, as it is
//		used for generating the elapsed time count for solving puzzles!
//	It could be done getting the time of day, and subtracting that from the
//  time of day when the program started, but the Windows GetTickCount() function
//	works nicely, too.

DWORD KGetTicks(void)
{
	static double sMillisecondsPerBeat = 0.0;
	DWORD	retval;
	
	// If this is the first time here, create a conversion factor
	// so we can convert the timebase registers to milliseconds.
	if (sMillisecondsPerBeat == 0.0)
	{
		mach_timebase_info_data_t timebase;
		mach_timebase_info (&timebase);
		
		// Convert nanosecond result to milliseconds
		sMillisecondsPerBeat = (double) timebase.numer / (double) timebase.denom * 0.000001;
	}
	
	// Read the timebase registers and convert to ms.
	uint64_t ticks = mach_absolute_time();
	retval = (DWORD)(ticks * sMillisecondsPerBeat);
	return retval;
}

//*****************************************************************
bool inSleep=false;

void KSleep(DWORD tm) {
	
	if( tm>0 ) {
		inSleep = true;
        if( dirtyX1<dirtyX2 ) {
            InvDirty();
            while( dirtyX1 < dirtyX2 );
        }
		usleep(tm*1000);
		inSleep = false;
	}
}

//**********************************************************
void KSetCursor(WORD curtype)
{
	//	curtype = 0 for normal, 1 for wait, 2 for hotlink
	switch (curtype) {
		case 0:		[[NSCursor arrowCursor] set]; break;
			//		case 1:		[[NSCursor watchCursor] set]; break;
		case 2:		[[NSCursor pointingHandCursor] set]; break;
		default:	[[NSCursor arrowCursor] set]; break;
	}
}

void KCaptureMouse(BOOL cap)
{
	//	MacNotImplemented();
}

bool inSetTitle=false;

// We can't pass this as function argument because the function gets run ASYNCHRONOUSLY on the UI thread,
// so the value will lilkely have changed by the time the UI thread runs the code.
char titleBuf[512];

//**********************************************************
void KSetTitle(void) {
	
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
//	dispatch_async( dispatch_get_main_queue(), ^{
		NSString *windowTitle;
		
		windowTitle = [NSString stringWithCString:(const char*)titleBuf encoding:NSUTF8StringEncoding];
		inSetTitle = true;
		[[kApp window] setTitle:windowTitle];
		inSetTitle = false;
//	});
    }];
	return;
}

// TODO: line and BMB positioning is kinda hacky owing to accounting for font metrics.
// Instead of compensating by the margin.top/2, need to compensate by the height of the current font.

PMPrintSession printSession = NULL;
PMPrintSettings printSettings = NULL;
PMPageFormat pageFormat = NULL;
PMOrientation orientation = kPMPortrait;
PMPaper paper;
PMPaperMargins paperMargins;
double pageWidth, pageHeight;

bool printFontFixed = true;
CGFloat printFontSize = 12.0f;
bool printFontBold = false;
bool printFontItalic = false;

CGContextRef cgPrintingContext = NULL;

NSView *pKPV=nil;

//***********************************************************
// Return 0 if fail, non-0 if succeed (and set pw, ph, Xppi, Yppi)
// Get everything setup for printing which is to follow
DWORD KPrintStart(DWORD *pw, DWORD *ph, DWORD *Xppi, DWORD *Yppi)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintStart\n");
#endif
	
	DWORD retVal = 0;

	
	// Create a view
//	if( nil != [[kintPrintView alloc] initWithFrame:CGRectMake(0, 0, 700, 700)] ) {

		
//	}
	
	 gInPrintLoop = true;
	 
	 if( noErr!=PMCreateSession (&printSession) ) goto cantCreateSession;
	 if( noErr!=PMCreatePrintSettings (&printSettings) ) goto cantCreateSettings;
	 if( noErr!=PMSessionDefaultPrintSettings (printSession, printSettings) ) goto cantSetDefaults;
	 
	 //	require_noerr( PMPrintSettingsSetJobName (printSettings, windowTitleRef), cantSetJobName);
	 
	 if( noErr!=PMCreatePageFormat (&pageFormat) ) goto cantCreatePageFormat;
	 if( noErr!=PMSessionDefaultPageFormat (printSession,  pageFormat) ) goto cantGetDefaultPageFormat;
	 
	 if( noErr!=PMSessionSetDestination (printSession, printSettings, kPMDestinationPreview, kPMDocumentFormatPDF, NULL) ) goto cantSetDestination;
	 
	 Boolean result;
	 if( noErr!=PMSessionValidatePageFormat (printSession, pageFormat, &result) ) goto cantValidateFormat;
	 
	 if( noErr!=PMGetPageFormatPaper (pageFormat, &paper) ) goto cantGetPaper;
	 if( noErr!=PMPaperGetWidth (paper, &pageWidth) ) goto cantGetPaperWidth;
	 if( noErr!=PMPaperGetHeight (paper, &pageHeight) ) goto cantGetPaperHeight;
	 if( noErr!=PMPaperGetMargins (paper, &paperMargins) ) goto cantGetPaperMargins;
	 
	 if( noErr!=PMGetOrientation (pageFormat, &orientation) ) goto cantGetPaperOrientation;
	 // Landscape paper sizes have the width and height reversed.
	 if (orientation == kPMLandscape || orientation == kPMReverseLandscape)
	 {
	 double temp;
	 temp = pageHeight;
	 pageHeight = pageWidth;
	 pageWidth = temp;
	 }
	 *pw = pageWidth - (paperMargins.left + paperMargins.right);
	 *ph = pageHeight - (paperMargins.top + paperMargins.bottom);
	 
	 // This may tickle the idle timer, so we have to set gInPrintLoop beforehand.
	 if( noErr!=PMSessionBeginCGDocumentNoDialog (printSession, printSettings, pageFormat) ) goto cantBeginSession;
	 
	 *Xppi = (DWORD)72;
	 *Yppi = (DWORD)72;
	 
	 #if _DEBUG && DEBUG_PRINT
	 printf("  w: %d h: %d x ppi: %d y ppi: %d\n", *pw, *ph, *Xppi, *Yppi);
	 #endif
	 
	 retVal = 1;
	 
	 cantCreateSession:
	 cantCreateSettings:
	 cantSetDefaults:
	 cantSetJobName:
	 cantCreatePageFormat:
	 cantGetDefaultPageFormat:
	 cantSetDestination:
	 cantValidateFormat:
	 cantGetPaper:
	 cantGetPaperWidth:
	 cantGetPaperHeight:
	 cantGetPaperOrientation:
	 cantGetPaperMargins:
	 cantBeginSession:
	
	if (retVal == 0)
		KPrintStop();
	
	return retVal;
}

//*******************************************************
// Shutdown and clean up after printing, we're all through
void KPrintStop(void)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintStop\n");
#endif
	
//	[[NSPrintOperation printOperationWithView:pKPV] runOperation];

	if (pageFormat)	{
		PMRelease (pageFormat);
		pageFormat = NULL;
	}
	if (printSettings) {
		PMRelease (printSettings);
		printSettings = NULL;
	}
	if (printSession) {
		PMSessionEndDocumentNoDialog(printSession);
		PMRelease (printSession);
		printSession = NULL;
	}
	 
	gInPrintLoop = false;
}

//*****************************************************
//	return non-0 if successful, 0 if fail
BYTE KPrintBeginPage(void)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintBeginPage\n");
#endif
	BYTE retVal = 0;

	if( noErr!=PMSessionBeginPageNoDialog(printSession, pageFormat, NULL) ) goto cantBeginPage;
	if( noErr!=PMSessionGetCGGraphicsContext(printSession, &cgPrintingContext) ) goto cantGetContext;
	 
//	CGContextSelectFont(cgPrintingContext, printFontFixed ? "Courier" : "Helvetica", printFontSize, kCGEncodingMacRoman);
	retVal = 1;
	
cantBeginPage:
cantGetContext:
	return retVal;
}

//*****************************************************
//	return non-0 if successful, 0 if fail

BYTE KPrintEndPage(void)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintEndPage\n");
#endif
	if( noErr!=PMSessionEndPageNoDialog(printSession) ) return 0;
	return 1;
}

//******************************************************
void KPrintText(int x, int y, char *str, DWORD clr)
{
#if _DEBUG && DEBUG_PRINT
    printf("KPrintText x: %d y: %d %s\n", x, y, str);
#endif
    
    //	CGContextShowTextAtPoint(cgPrintingContext, x + paperMargins.left, pageHeight - y - paperMargins.top, str, strlen(str));
    
    [NSGraphicsContext saveGraphicsState];
    NSGraphicsContext   *nsGC = [NSGraphicsContext graphicsContextWithCGContext:cgPrintingContext flipped:NO];
    [NSGraphicsContext setCurrentContext:nsGC];
    
    NSString *nsStr = [NSString stringWithCString:(const char*)str encoding:NSUTF8StringEncoding];
    
//    NSString *pFontStyle;
    NSString *pFontName;
    NSFont  *fnt;

    if( printFontFixed ) {
        if( printFontBold ) {
            if( printFontItalic ) pFontName = @"Courier-BoldOblique";
            else pFontName = @"Courier-Bold";
        } else if( printFontItalic ) {
            pFontName = @"Courier-Oblique";
        } else pFontName = @"Courier";
    } else {
        if( printFontBold ) {
            if( printFontItalic ) pFontName = @"Helvetica-BoldOblique";
            else pFontName = @"Helvetica-Bold";
        } else if( printFontItalic ) {
            pFontName = @"Helvetica-Oblique";
        } else pFontName = @"Helvetica";
    }
    NSMutableDictionary *attribs = [[NSMutableDictionary alloc] init];
    fnt = [NSFont fontWithName:pFontName size:printFontSize];//12.0];

    [attribs setObject:fnt forKey:NSFontAttributeName];
    [attribs setObject:[NSColor colorWithRed:0.0 green:0.0 blue:0.0 alpha:1.0] forKey:NSForegroundColorAttributeName];
    [nsStr drawAtPoint:CGPointMake(x+ paperMargins.left,pageHeight - y - paperMargins.top) withAttributes:attribs];

    [NSGraphicsContext restoreGraphicsState];
}

//***********************************************************
void KPrintGetTextSize(char *str, DWORD *dw, DWORD *dh, DWORD *dasc)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintGetTextSize\n");
#endif
	CGPoint start, end;
	CGContextSetTextDrawingMode(cgPrintingContext, kCGTextInvisible);
	start = CGContextGetTextPosition(cgPrintingContext);
    
//	CGContextShowText(cgPrintingContext, str, strlen(str));

    NSString *nsStr = [NSString stringWithCString:(const char*)str encoding:NSUTF8StringEncoding];
    [nsStr drawAtPoint:start withAttributes:@{NSFontAttributeName:[NSFont fontWithName:printFontFixed ? @"Courier" : @"Helvetica" size:printFontSize]}];
    
    
    
    end = CGContextGetTextPosition(cgPrintingContext);
	CGContextSetTextDrawingMode(cgPrintingContext, kCGTextFill);
	CGContextSetTextPosition(cgPrintingContext, start.x, start.y);
	
	*dw = end.x - start.x;
	// TODO: deal with metrics for CG
	*dh = 12;
	*dasc = 10;
}

//**************************************************************************
void KPrintBMB(int xd, int yd, int wd, int hd, PBMB bmS, int xs, int ys, int ws, int hs)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintBMB\n");
#endif
	
	// Sherlock will pass in a NULL bmS if you try to print a puzzle, so we check for that and
	// exit early to avoid a crash.
	if (bmS == NULL) return;
	
	CGContextRef bitmapContext = NULL;
	CGColorSpaceRef colorSpace = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB);
	bitmapContext = CGBitmapContextCreate (bmS->pBits + (xs*kPixSize) + (bmS->linelen * ys), ws, hs, 8, bmS->linelen, colorSpace, kCGImageAlphaNoneSkipFirst);
	CGColorSpaceRelease (colorSpace);
	
	CGImageRef image = CGBitmapContextCreateImage (bitmapContext);
	
	CGRect cgRect = CGRectMake(xd + paperMargins.left, pageHeight - yd - hd - (paperMargins.top / 2), wd, hd);
	CGContextDrawImage (cgPrintingContext, cgRect, image);
	CGImageRelease (image);
	CGContextRelease (bitmapContext);
}

//**************************************************************************
void KPrintRect(int xd, int yd, int wd, int hd, DWORD fillcolor, DWORD edgecolor)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintRect\n");
#endif
	CGContextSaveGState(cgPrintingContext);
	
	CGColorSpaceRef cgColorSpace = CGColorSpaceCreateWithName (kCGColorSpaceGenericRGB);
	
	// fillcolor and edgecolor should be in ARGB format, so need to pack them into the float array in RGBA format.
	CGFloat tempColor[4];
	
	CGRect cgRect = CGRectMake(xd + paperMargins.left, pageHeight - yd - hd - (paperMargins.top / 2), wd, hd);
	
	if (fillcolor != 0xffffffff)
	{
		tempColor[0] = (float)((fillcolor & 0x00ff0000) >> 16) / 255.0f;	// R
		tempColor[1] = (float)((fillcolor & 0x0000ff00) >> 8) / 255.0f;		// G
		tempColor[2] = (float)(fillcolor & 0x000000ff) / 255.0f;			// B
		tempColor[3] = (float)((fillcolor & 0xff000000) >> 24) / 255.0f;	// A
		
		// The games use 0 to indicate an opaque alpha, so invert it for CoreGraphics
		tempColor[3] = 1.0f - tempColor[3];
		
		CGColorRef cgFillColor = CGColorCreate (cgColorSpace, tempColor);
		
		CGContextSetFillColorWithColor (cgPrintingContext, cgFillColor);
		CGContextFillRect (cgPrintingContext, cgRect);
		CGColorRelease (cgFillColor);
	}
	
	if (edgecolor != 0xffffffff)
	{
		tempColor[0] = (float)((edgecolor & 0x00ff0000) >> 16) / 255.0f;	// R
		tempColor[1] = (float)((edgecolor & 0x0000ff00) >> 8) / 255.0f;		// G
		tempColor[2] = (float)(edgecolor & 0x000000ff) / 255.0f;			// B
		tempColor[3] = (float)((edgecolor & 0xff000000) >> 24) / 255.0f;	// A
		
		// The games use 0 to indicate an opaque alpha, so invert it for CoreGraphics
		tempColor[3] = 1.0f - tempColor[3];
		
		CGColorRef cgStrokeColor = CGColorCreate (cgColorSpace, tempColor);
		
		CGContextSetStrokeColorWithColor (cgPrintingContext, cgStrokeColor);
		CGContextStrokeRect (cgPrintingContext, cgRect);
		CGColorRelease (cgStrokeColor);
	}
	CGColorSpaceRelease (cgColorSpace);
	
	CGContextRestoreGState(cgPrintingContext);
}

//************************************************************************************
void KPrintFont(WORD hlim, WORD flags, WORD *h, WORD *asc)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintFont\n");
#endif
	// flags:
	// bit 0: 1 = fixed-width (Win32: "Courier New" vs. "Tahoma")
	// bit 1: 1 = bold
	// bit 2: 1 = italic
	
	printFontFixed = (flags & 0x01);
	printFontSize = hlim - 2;
	printFontBold = (flags & 0x02);
	printFontItalic = (flags & 0x04);
	
//	CGContextSelectFont(cgPrintingContext, printFontFixed ? "Courier" : "Helvetica", printFontSize, kCGEncodingMacRoman);
	// TODO: deal with bold/italic for CG
	// TODO: deal with metrics for CG
	*h = hlim;
	*asc = hlim - 2;
}

//*********************************************************
void KPrintLines(DWORD *pMem, WORD numpoints, DWORD clr)
{
#if _DEBUG && DEBUG_PRINT
	printf("KPrintLines\n");
#endif
	
	 int		i, j;
	 
	 CGContextSaveGState(cgPrintingContext);
	 
	 CGColorSpaceRef cgColorSpace = CGColorSpaceCreateWithName (kCGColorSpaceGenericRGB);
	 
	 // fillcolor and edgecolor should be in ARGB format, so need to pack them into the float array in RGBA format.
	 CGFloat tempColor[4];
	 
	 tempColor[0] = (float)((clr & 0x00ff0000) >> 16) / 255.0f;	// R
	 tempColor[1] = (float)((clr & 0x0000ff00) >> 8) / 255.0f;	// G
	 tempColor[2] = (float)(clr & 0x000000ff) / 255.0f;			// B
	 tempColor[3] = (float)((clr & 0xff000000) >> 24) / 255.0f;	// A
	 
	 // The games use 0 to indicate an opaque alpha, so invert it for CoreGraphics
	 tempColor[3] = 1.0f - tempColor[3];
	 
	 CGColorRef cgStrokeColor = CGColorCreate (cgColorSpace, tempColor);
	 CGContextSetStrokeColorWithColor (cgPrintingContext, cgStrokeColor);
	 
	 // KINT uses the first and last points once, and in between points twice,
	 // where OS-X expects two points for every line segment, so we have to adjust.
	 CGPoint *points = (CGPoint *)malloc(2*(numpoints-1)*sizeof(CGPoint));
	 
	 i = j = 0;
	 points[i].x = EndianU32_LtoN(pMem[j++]) + paperMargins.left;
	 points[i].y = pageHeight - EndianU32_LtoN(pMem[j++]) - (paperMargins.top / 2) - 2;
	 
	 for(++i; i < 2*(numpoints-1)-1; i+=2) {
	 points[i].x = points[i+1].x = EndianU32_LtoN(pMem[j]) + paperMargins.left;
	 j++;
	 points[i].y = points[i+1].y = pageHeight - EndianU32_LtoN(pMem[j]) - (paperMargins.top / 2) - 2;
	 j++;
	 }
	 points[i].x = EndianU32_LtoN(pMem[j++]) + paperMargins.left;
	 points[i].y = pageHeight - EndianU32_LtoN(pMem[j++]) - (paperMargins.top / 2) - 2;
	 
	 CGContextStrokeLineSegments(cgPrintingContext, points, 2*(numpoints-1));
	 
	 free(points);
	 
	 CGColorRelease (cgStrokeColor);
	 CGColorSpaceRelease (cgColorSpace);
	 CGContextRestoreGState (cgPrintingContext);
	
	
}

// We can't pass these as function arguments because the function gets run ASYNCHRONOUSLY on the UI thread,
// so the values will lilkely have changed by the time the UI thread runs the code.
DWORD	SWPopt=0, SWPh, SWPw, SWPy, SWPx, SWPvw=1100, SWPvh=600;
DWORD dS1,dS2,dS3,dS4,dS5;

void (^SSWPblock)(void);

volatile DWORD sswpFLAG;
void SetSWPv(void) {
	
    if( sswpFLAG ) NSLog(@"sswpFLAG");
    if( NSThread.currentThread.isMainThread ) {
        sswpFLAG = false;
//        Dwrite("SetSWPv isMain");
        SWPvw = SWPw-(DWORD)(kApp.window.frame.size.width - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.width);
        SWPvh = SWPh-(DWORD)(kApp.window.frame.size.height - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.height);
    } else {
        sswpFLAG = true;
//        Dwrite("SetSWPv notMain");
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            DWORD x,y,w,h;
            x = [[kApp window].contentView frame].origin.x;
            y = [[kApp window].contentView frame].origin.y;
            w = [[kApp window].contentView frame].size.width;
            h = [[kApp window].contentView frame].size.height;

            SWPvw = SWPw-(DWORD)(kApp.window.frame.size.width - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.width);
            SWPvh = SWPh-(DWORD)(kApp.window.frame.size.height - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.height);
            sswpFLAG = false;
        }];
    }
    while( sswpFLAG )
        ;
/*    {
        char dBuf[128];
        sprintf(dBuf,"SetSWPv: %d x %d",SWPvw,SWPvh);
        Dwrite(dBuf);
    }
*/
}

DWORD   lastGoodGetX, lastGoodGetY, lastGoodGetW, lastGoodGetH, lastGoodGetOpt;
volatile DWORD   swpFLAG;
//***********************************************************************
void KINT_SetWindowPos(void)
{
    BOOL t = InSetWindowPos;

//    if( swpFLAG ) NSLog(@"swpFLAG");
//    Dwrite("KINT_SetWindowPos 1");
    if( SWPw<1 || SWPh<1 ) {
        SWPx = lastGoodGetX;
        SWPy = lastGoodGetY;
        SWPw = lastGoodGetW;
        SWPh = lastGoodGetH;
        SWPopt = lastGoodGetOpt;
    }
    if( SWPw<600 || SWPh<400 ) {
        SWPx = 30;
        SWPy = 20;
        SWPw = 600;
        SWPh = 400;
    }
    if (!windowReady) return;
    if( NSThread.currentThread.isMainThread ) {
        swpFLAG = false;
/*        {
            char dBuf[128];
            sprintf(dBuf,"KINT_SetWindowPos m: %d,%d,%d,%d",SWPx,SWPy,SWPw,SWPh);
            Dwrite(dBuf);
        }
*/
        InSetWindowPos = TRUE;
        if( SWPopt==0 ) {
            NSRect    rect = NSMakeRect((CGFloat)SWPx, (CGFloat)SWPy, (CGFloat)SWPw, (CGFloat)SWPh);
            [[kApp window] setFrame:rect display:YES];
        }
        if( (SWPopt && !isFullScreen) || (!SWPopt && isFullScreen) ) {
            [[kApp window] toggleFullScreen:nil];
        }
        InSetWindowPos = t;
    } else {
        swpFLAG = true;
/*        {
            char dBuf[128];
            sprintf(dBuf,"KINT_SetWindowPos n: %d,%d,%d,%d",SWPx,SWPy,SWPw,SWPh);
            Dwrite(dBuf);
        }
*/        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
		InSetWindowPos = TRUE;
        if( SWPopt==0 ) {
            NSRect	rect = NSMakeRect((CGFloat)SWPx, (CGFloat)SWPy, (CGFloat)SWPw, (CGFloat)SWPh);
            [[kApp window] setFrame:rect display:YES];
        }
        if( (SWPopt && !isFullScreen) || (!SWPopt && isFullScreen) ) {
            [[kApp window] toggleFullScreen:nil];
        }
		InSetWindowPos = t;
        swpFLAG = false;
        }];
    }
    while( swpFLAG )
        ;
}

volatile DWORD gwpFLAG;
//**************************************************************************
void KINT_GetWindowPos(DWORD *r11, DWORD *r12, DWORD *r13, DWORD *r14, DWORD *r15)
{
/*    if( gwpFLAG ) NSLog(@"gwpFLAG");
    {
        char dBuf[128];
        sprintf(dBuf,"KINT_GetWindowPos 1 &gwpF=%p",&gwpFLAG);
        Dwrite(dBuf);
    }
*/
    if (!windowReady) return;
    dS1 = (DWORD)isFullScreen;
    if( NSThread.currentThread.isMainThread ) {
//        Dwrite("KINT_GetWindowPos m");
        gwpFLAG = 0;
        NSRect windowBounds = [[kApp window] frame];
        dS5 = windowBounds.origin.x; // x
        dS4 = windowBounds.origin.y; // y
        dS3 = windowBounds.size.width; // w
        dS2 = windowBounds.size.height; // h
    } else {
//        Dwrite("KINT_GetWindowPos n");
        gwpFLAG = 1;
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
//            Dwrite("KINT_GetWindowPos n1");
            NSRect windowBounds = [[kApp window] frame];
//            Dwrite("KINT_GetWindowPos n2");
            dS5 = windowBounds.origin.x;
            dS4 = windowBounds.origin.y;
            dS3 = windowBounds.size.width;
            dS2 = windowBounds.size.height;
//            Dwrite("KINT_GetWindowPos n3");
#if _DEBUG
	printf("KINT_GetWindowPos, cmd: %08x, h: %d, w: %d, top: %d, left: %d\n", *r11, *r12, *r13, *r14, *r15);
#endif
            gwpFLAG = 0;
/*            {
                char dBuf[128];
                sprintf(dBuf,"KINT_GetWindowPos n4 &gwpF=%p",&gwpFLAG);
                Dwrite(dBuf);
            }
*/
            
        }];
    }
/*    {
        char dBuf[128];
        sprintf(dBuf,"KINT_GetWindowPos 5: gwpF=%d",gwpFLAG);
        Dwrite(dBuf);
    }
*/
    while( gwpFLAG )
        ;
/*    {
        char dBuf[128];
        sprintf(dBuf,"KINT_GetWindowPos 6: %d,%d,%d,%d",dS5,dS4,dS3,dS2);
        Dwrite(dBuf);
    }
*/
    // the following save is in case a 0 or negative value is sent
    // for SETTING the window position, and we can use this instead.
    if( dS3>0 && dS2>0 ) {
        lastGoodGetX = dS5;
        lastGoodGetY = dS4;
        lastGoodGetW = dS3;
        lastGoodGetH = dS2;
        lastGoodGetOpt = dS1;
    }
    *r11 = dS1;
    *r12 = dS2;
    *r13 = dS3;
    *r14 = dS4;
    *r15 = dS5;
}

MusicPlayer	musicPlayer;
MusicSequence sequence;
DWORD nTracks;
MusicTimeStamp sequenceLength;

//*********************************************************
void StopMusic(void) {
	
	Boolean retval;
	
	if( MusicPlaying ) {
		MusicPlayerIsPlaying(musicPlayer, &retval);
		if( retval ) {
			MusicPlayerStop(musicPlayer);
			DisposeMusicPlayer(musicPlayer);
			DisposeMusicSequence(sequence);
		}
	}
	MusicPlaying = 0;
}

//******************************
int KMusicIsBusy(void) {
	
	Boolean	retval=NO;
	MusicTimeStamp curTime;
	
	if( MusicPlaying ) {
		MusicPlayerIsPlaying(musicPlayer, &retval);
		if( retval ) {
			MusicPlayerGetTime(musicPlayer, &curTime);
			if( curTime >= sequenceLength ) {
				StopMusic();
				AddMsg(KHDR_MUSIC_DONE, 0, 0, 0);
			}
			retval = MusicPlaying;
		}
	}
	return (int)retval;
}

//****************************************************************************
void PlayMusic(char *pMem)
{
#if _DEBUG && DEBUG_SOUND
	printf("PlayMusic: %s\n", pMem);
#endif
	BuildPath(pMem, DIR_MUSIC, TRUE);
	
	StopMusic();
	
	OSStatus	res=noErr;
	
	res = NewMusicPlayer(&musicPlayer);
	res = NewMusicSequence(&sequence);
	strcpy(TmpPath, "MUSIC/");
	strcat(TmpPath, pMem);
	strcat(TmpPath, ".MID");
	NSString *iName = [NSString stringWithUTF8String:TmpPath];
	NSURL   *url = [[NSBundle mainBundle] URLForResource:iName withExtension:nil];
	
	res = MusicSequenceFileLoad (sequence, (__bridge CFURLRef _Nonnull)(url), 0, kMusicSequenceLoadSMF_ChannelsToTracks);
	res = MusicPlayerSetSequence(musicPlayer, sequence);
	res = MusicSequenceGetTrackCount(sequence, &nTracks);
	sequenceLength = 0;
	for(DWORD i=0; i<nTracks; i++) {
		MusicTrack track;
		MusicTimeStamp trackLength=0;
		DWORD propsize=sizeof(MusicTimeStamp);
		res = MusicSequenceGetIndTrack(sequence, i, &track);
		res = MusicTrackGetProperty(track, kSequenceTrackProperty_TrackLength, &trackLength, &propsize);
		if( trackLength > sequenceLength ) sequenceLength = trackLength;
	}
	sequenceLength += 1;	// or however many beats you want to add on the end for settling time
	res = MusicPlayerSetTime(musicPlayer, (MusicTimeStamp)0);
	res = MusicPlayerStart(musicPlayer);
	
	if( res==noErr ) MusicPlaying = 1;
}

//*******************************************************************
void KPlaySound(char *pMem) {
	
#if _DEBUG && DEBUG_SOUND
	printf("KPlaySound: %s\n", pMem);
#endif
	strcpy(TmpPath, pMem);
	strcat(TmpPath, ".WAV");
    if( NSThread.currentThread.isMainThread ) {
        float    volume=100.0;
        NSString *iName = [NSString stringWithUTF8String:TmpPath];
        NSURL   *url = [[NSBundle mainBundle] URLForResource:iName withExtension:nil];
        NSError *error;
        pKV.audioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
        pKV.audioPlayer.numberOfLoops = 0;
        pKV.audioPlayer.volume = (float)volume/100.0;
        if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
        else [pKV.audioPlayer play];
    } else {
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            float    volume=100.0;

            NSString *iName = [NSString stringWithUTF8String:TmpPath];
            NSURL   *url = [[NSBundle mainBundle] URLForResource:iName withExtension:nil];
            NSError *error;
            pKV.audioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
            pKV.audioPlayer.numberOfLoops = 0;
            pKV.audioPlayer.volume = (float)volume/100.0;
            if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
            else [pKV.audioPlayer play];
        }];
    }
}

//*******************************************************************
void KPlaySoundMem(char *pMem, KLONG len, BOOL nostop) {
	
    if( NSThread.currentThread.isMainThread ) {
        float	volume=100.0;

        if( [pKV.audioPlayer isPlaying]==YES ) {
            if( nostop ) return;
            [pKV.audioPlayer stop];
        }
        NSError *error;
        pKV.audioPlayer = [[AVAudioPlayer alloc] initWithData:[[NSData alloc] initWithBytes:pMem length:len] error:&error];
    //	NSLog(@"%@",error);
        pKV.audioPlayer.numberOfLoops = 0;
        pKV.audioPlayer.volume = (float)volume/100.0;
        if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
        else [pKV.audioPlayer play];
    } else {
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            float    volume=100.0;

            if( [pKV.audioPlayer isPlaying]==YES ) {
                if( nostop ) return;
                [pKV.audioPlayer stop];
            }
            NSError *error;
            pKV.audioPlayer = [[AVAudioPlayer alloc] initWithData:[[NSData alloc] initWithBytes:pMem length:len] error:&error];
        //    NSLog(@"%@",error);
            pKV.audioPlayer.numberOfLoops = 0;
            pKV.audioPlayer.volume = (float)volume/100.0;
            if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
            else [pKV.audioPlayer play];
        }];
    }
}

//------------------------------------------------------------------------------------
// • wildicmp
//------------------------------------------------------------------------------------
// Case-insensitive wildcard matching.
// Matches against ? and *. Returns nonzero if match found, 0 if no match.

int wildicmp(const char *string, const char *wild)
{
	const char *charP = NULL, *wildP = NULL;
	
	// Attempt to match the string up to the first "*"
	while ((*string) && (*wild != '*'))
	{
		// No exact or ? match, so fail
		if ((*wild != '?') && (tolower(*wild) != tolower(*string)))
			return 0;
		
		// Otherwise move to the next char in each string
		wild++;
		string++;
	}
	
	// Match the rest of the string.
	while (*string)
	{
		// See if we hit a * token
		if (*wild == '*')
		{
			// If we're at the end of the wild string, we're done and we match.
			if (!*++wild)
				return 1;
			
			// wild and wildP are now the char after the * token
			wildP = wild;
			// advance to the next source char after this.
			charP = string+1;
		}
		// No * token, check for exact and ? matches.
		else if ((*wild == '?') || (tolower(*wild) == tolower(*string)))
		{
			wild++;
			string++;
		}
		else
		{
			// No match. If wildP is not NULL, we've got a * search and can consume another entry
			// in "string".
			// Otherwise we'll fail the match next time through the loop due to wild being NULL.
			wild = wildP;
			string = charP++;
		}
	}
	
	// Consume any * tokens at the end of the string
	while (*wild == '*')
		wild++;
	
	// If we're past the last * token in the wild string, we'll either be NULL or we won't
	// match (i.e. the wild string was longer than the source).
	return !*wild;
}

int stricmp(const char *s, const char *d) {
	
	while( *s && *d ) {
		if( tolower(*s) != tolower(*d) ) break;
		++s;
		++d;
	}
	if( *s < *d ) return -1;
	if( *s > *d ) return  1;
	return 0;
}

//****************************************************
// Terminate the Kfindfirst()/Kfindnext() process
void Kfindclose() {
	
	FIRSTNEXT	*pNext;
	
	while( pFirstNext != NULL ) {
		pNext = pFirstNext->pNext;
		free(pFirstNext);
		pFirstNext = pNext;
	}
	pNextNext = NULL;
}

char macName[256];

//**************************************
void Kff(BOOL AppData, BOOL stripEXT) {
	
	FIRSTNEXT	*pLast;
	char		nbuf[PATHLEN];
	int			i;
	DWORD		attribs;
	
	for(i=(int)strlen(TmpPath)-1; i>=0; i--) if( TmpPath[i]=='/' ) break;
	if( i>=0 && TmpPath[i]=='/' ) {
		strcpy(macName, TmpPath+i+1);
		TmpPath[i+1] = 0;
	} else {
		strcpy(macName, TmpPath);
		strcpy(TmpPath, "./");
	}
	
	NSString *fPath = [NSString stringWithUTF8String:TmpPath];
	NSString *filename=nil;
	NSFileManager *fileManager = [[NSFileManager alloc] init];
	NSURL	*fileURL = [NSURL fileURLWithPath:fPath];
	
	NSDirectoryEnumerator *dirEnum = [fileManager enumeratorAtURL:fileURL includingPropertiesForKeys:[NSArray arrayWithObject:NSURLIsDirectoryKey] options:NSDirectoryEnumerationSkipsSubdirectoryDescendants | NSDirectoryEnumerationSkipsHiddenFiles | NSDirectoryEnumerationSkipsPackageDescendants errorHandler:nil];//localFileManager enumeratorAtPath:fPath];
	for(NSURL *urlItem in dirEnum) {
		attribs = 0;
		NSNumber *isDir=nil;
		if( [urlItem getResourceValue:&isDir forKey:NSURLIsDirectoryKey error:nil]) {
			if( [isDir isEqual:[NSNumber numberWithInt:1]] ) {
				attribs |= 0x10;
			}
		}
		filename = [urlItem lastPathComponent];
		[filename getCString:nbuf maxLength:sizeof(nbuf) encoding:NSUTF8StringEncoding];
		if( wildicmp(nbuf, macName) ) {
			if( stripEXT ) {
				for(i=(int)strlen(nbuf)-1; i>=0; i--) {
					if( nbuf[i]=='.' ) {
						nbuf[i] = 0;
						break;
					}
					if( nbuf[i]=='/' ) break;
				}
			}
			// if first one, just alloc a struct and go on
			if( pFirstNext==NULL ) {
				pFirstNext = pLast = (FIRSTNEXT *)malloc(sizeof(FIRSTNEXT)+strlen(nbuf));
				// else if not first one, check for duplicate fname
			} else {
				for(pLast=pFirstNext; ; pLast=pLast->pNext) {
					// if duplicate fname, skip this one, don't add it, don't allocate, don't collect $200
					if( !stricmp((char*)(pLast->fname), (char*)nbuf) ) goto dupe;
					if( pLast->pNext==NULL ) break;
				}
				// new fname, alloc a struct and go on
				pLast->pNext = (FIRSTNEXT *)malloc(sizeof(FIRSTNEXT)+strlen(nbuf));
				if( pLast->pNext!=NULL ) pLast = pLast->pNext;
				else SystemMessage("kFF:N");
			}
			
			pLast->pNext = NULL;
			pLast->AppData = AppData;
			pLast->attrib = (BYTE)attribs;
			strcpy((char*)(pLast->fname), (char*)nbuf);
		dupe:;
		}
	}
}

//******************************************************************
// Search for a filename (possibly containing '*' as wild card)
DWORD Kfindfirst(char *fname, BYTE *fbuf, BYTE *attrib, BYTE *appdata, BYTE dir) {
	
	BOOL	stripEXT;
	
	Kfindclose();
	
	stripEXT = dir!=DIR_GAME && !(dir & DIR_NOEXT);
	
	BuildPath(fname, dir, TRUE);
	Kff(TRUE, stripEXT);
	
	BuildPath(fname, dir, FALSE);	// now search the PgmPath directory tree
	Kff(FALSE, stripEXT);
	
	if( pFirstNext ) {
		*attrib = pFirstNext->attrib;
		*appdata = pFirstNext->AppData;
		strcpy((char*)fbuf, (char*)(pFirstNext->fname));
		pNextNext = pFirstNext->pNext;
		return 0;
	}
	return 0xFFFFFFFF;
}

//********************************************************************
// Search for next filename in sequence started by Kfindfirst()
DWORD Kfindnext(BYTE *fbuf, BYTE *attrib, BYTE *appdata) {
	
	if( pNextNext!=NULL ) {
		*attrib = pNextNext->attrib;
		*appdata = pNextNext->AppData;
		strcpy((char*)fbuf, (char*)(pNextNext->fname));
		pNextNext = pNextNext->pNext;
		return 0;
	}
	return 0xFFFFFFFF;
}

void KillProgram(void) {

//	DumpDR();
	ForceMsg(KHDR_SHUT_DOWN, 0, 0, 0);
	SysCleanup();
	exit(0);
}


