//
//  kintKINT.h
//  iKINT
//
//  Created by Everett Kaser on 1/8/13.
//  Copyright (c) 2013 Everett Kaser. All rights reserved.
//

// Year is since 1900, Month is 0-11, Day is 1-31
#define	BETA	0

#define	BETA_YEAR	2018
#define	BETA_MONTH	11
#define	BETA_DAY	11
#define	BETAKEY		0xAACD99AB

//***************************
//* KINT version numbers
//***************************
#if BETA
	#define	INTERP_MAJOR_REV	132
	#define	INTERP_MINOR_REV	9
	extern 	KTIME	betatime;
#else
	#define	INTERP_MAJOR_REV	5
	#define	INTERP_MINOR_REV	0
#endif

#define MAC_PORT	1

//include "kKINT.h"

extern volatile bool gInPrintLoop;

@import Foundation;
@import AudioToolbox.AudioServices;
#import <Cocoa/Cocoa.h>
//@import UIKit;
@import CoreGraphics;

@interface kintKINT : NSObject

@end

//*****************************************
//* VERSION TO BUILD **********************
//*
#define	KINT_DESKTOP_WINDOWS		0	//*	// set to 1 for running on an MS Windows desktop/notebook
#define	KINT_POCKET_PC				0	//*	// set to 1 for running on an MS Pocket PC
#define	KINT_UNIX					0	//*
#define	KINT_OSX					1	//*

#define	KINT_MS_WINDOWS	(KINT_DESKTOP_WINDOWS || KINT_POCKET_PC)

#if KINT_DESKTOP_WINDOWS				//*
#define	KINT_POCKET_PC_EMUL		0	//*	// set to 1 for emulating the PocketPC on a desktop
#define	KINT_DOUBLE_SIZE		0	//*	// set to 1 to draw the emulated PocketPC screen double-size
#else									//*
#define	KINT_POCKET_PC_EMUL		0	//*	// ALWAYS 0
#define	KINT_DOUBLE_SIZE		0	//*	// ALWAYS 0
#endif									//*

#if KINT_POCKET_PC						//*
#define	KINT_PRINT				0	//*	// ALWAYS 0
#define	KINT_MIDI				0	//*	// ALWAYS 0
#define	KINT_MAKE_COPY			0	//*	// ALWAYS 0
#else
#define	KINT_PRINT				1	//*	// set to 1 to include the SysPrint code
#define	KINT_MIDI				1	//*	// set to 1 to include the MIDI music playing code
#define	KINT_MAKE_COPY			1	//*	// set to 1 to include the SysMakeSharewareCopy code
#endif

//*
//* VERSION TO BUILD **********************
//*****************************************

#define	PATHLEN	1024

#if KINT_POCKET_PC
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#define MENU_HEIGHT	26
#endif

typedef uint8_t BYTE;
typedef uint16_t WORD;
typedef uint32_t DWORD;
typedef int8_t  KCHAR;
typedef int16_t KSHORT;
typedef int32_t KLONG;

#define FALSE	0
#define TRUE	1

//typedef	signed char	BOOL;
typedef	char		TCHAR;
#define	UNALIGNED

#ifndef NULL
	#define	NULL	0
#endif

#if KINT_OSX
#ifndef max
#define max(a,b) ((a) > (b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a) < (b) ? (a) : (b))
#endif
#define __min min
#define __max max
#define _stricmp strcasecmp
#define kPixSize (32/8)
// #define kPixSize (24/8)
#include <Carbon/Carbon.h>
#endif

#define	Kmin(a, b)	__min(a, b)
#define	Kmax(a, b)	__max(a, b)

// WM_SIZE defines for KINT
#define	K_SIZED		0
#define	K_MINIMIZED	1
#define	K_MAXIMIZED	2
#define	K_RESTORED	3

// These are used by the modifier-changed events
enum
{
	VK_SHIFT	= 0x10,
	VK_CONTROL	= 0x11,
	VK_MENU		= 0x12,
	VK_CAPITAL	= 0x14
};

// BMB rotation/flip orient values
#define	BMO_NORMAL	0	// normal orientation
#define	BMO_90		1	// rotated counter-clockwise 90
#define	BMO_180		2	// rotated counter-clockwise 180
#define	BMO_270		3	// rotated counter-clockwise 270
#define	BMO_FNORMAL	4	// flipped left-right
#define	BMO_F90		5	// flipped & rotated 90
#define	BMO_F180	6	// flipped & rotated 180
#define	BMO_F270	7	// flipped & rotated 270

/*
 #define	SO_WIDE		0	// non-flipped states must be even
 #define	SO_WIDEFLIP	1	// flipped states must be odd
 #define	SO_TALL		2
 #define	SO_TALLFLIP	3
 #define	SO_GET		4
 #define	SO_FLIPPED	1	// for testing for "flipped" status
 */

void SetAppDataPath(void);
void InitScreen(long minW, long minH);
void MakePalette(void);
void DestroyPalette(void);
void KillProgram(void);
void KINT_SetWindowPos(void);
void KINT_GetWindowPos(DWORD *r11, DWORD *r12, DWORD *r13, DWORD *r14, DWORD *r15);
void PlayMusic(char *pMem);
void StopMusic(void);
DWORD StartTimer(DWORD timval);
void StopTimer(DWORD);
void SystemMessage(char *pMem);
KLONG GetSystemEOL(BYTE *pMem);
char *GetFileName(char *fname, char *xname);

DWORD Kopen(char *fname, KLONG oflags, BYTE dir);
DWORD Kseek(DWORD fhandle, DWORD foffset, KLONG origin);
void Kclose(DWORD fhandle);
DWORD Kstat(char *fname, BYTE dir, DWORD *modtim, BYTE *filtyp);
DWORD Keof(DWORD fhandle);
DWORD Kread(DWORD fhandle, BYTE *pMem, DWORD numbytes);
DWORD Kwrite(DWORD fhandle, BYTE *pMem, DWORD numbytes);
void Kfindclose(void);
void Kdelete(char *fname, BYTE dir);
WORD KCopyFile(char *src, char *dst);
KLONG KMakeFolder(char *fname);
void KDelFolder(char *fname);

void KGetTime(KTIME *pT);
void KTimeToString(BYTE *pMem);
DWORD KGetTicks(void);
void KSetCursor(WORD curtype);

KLONG CreateBMB(short w, short h, WORD sysBM);
void DeleteBMB(DWORD index);
void InvalidateScreen(int x1, int y1, int x2, int y2);
void FlushScreen(void);

DWORD KPrintStart(DWORD *pw, DWORD *ph, DWORD *Xppi, DWORD *Yppi);
void KPrintStop(void);
BYTE KPrintBeginPage(void);
BYTE KPrintEndPage(void);
void KPrintText(int x, int y, char *str, DWORD clr);
void KPrintBMB(int xd, int yd, int wd, int hd, PBMB bmS, int xs, int ys, int ws, int hs);
void KPrintFont(WORD hlim, WORD flags, WORD *h, WORD *asc);
void KPrintLines(DWORD *pMem, WORD numpoints, DWORD clr);
void KPrintGetTextSize(char *str, DWORD *dw, DWORD *dh, DWORD *dasc);
void KPrintRect(int xd, int yd, int wd, int hd, DWORD fillcolor, DWORD edgecolor);
void KCaptureMouse(BOOL cap);
void KSleep(DWORD tmilli);
void KGetOSversion(BYTE *pMem);

#define MAXSNDS	30
extern	Boolean sndLoaded[MAXSNDS];
extern	SystemSoundID	sndID[MAXSNDS];

typedef struct {
	Boolean used;
	CGFloat	size;
	int		h, ah, flags;
	char	*fontName;
} FONT;
extern char	*fontNames[8];
#define MAXFONTS	16
extern FONT	kFONT[MAXFONTS];
extern int	FONTcnt;

extern BYTE	Kregs[256];

extern int			ScrW, ScrH;

extern KE	mainKE;	// struct for main .KE program

extern TCHAR	PgmPath[PATHLEN], TmpPath[PATHLEN], AppDataPath[PATHLEN], AppPath[PATHLEN];
//extern WindowRef gMacWindow;
extern bool windowReady;
extern CGContextRef gCGContext;

#define	MAXMSGS		1024	// max messages queued at a time in KINTmsgs
extern DWORD		KINTmsgs[4*MAXMSGS];
extern KLONG		KINTmsgadd, KINTmsgrem;
extern DWORD	KINTptrmove[4];
extern BOOL		KINTptrmovePENDING;

//*********************************************************************************
//* The following macros are used in PMACH.CPP in order to make
//* it easier for porting this code to "big-endian" CPUs.  "All" you have to do
//* is rewrite these macros, and MOST of the little-to-big-endian conversion will
//* be done.  Although, NO DOUBT, I've used these macros in some places where
//* I shouldn't have, and haven't used them in some places where I should have.
//* BEWARE!
//*********************************************************************************
#define GETREGQ(regoff)            (*((QWORD *)(Kregs + (regoff))))
#define GETREGD(regoff)			(*((DWORD *)(Kregs + (regoff))))
#define	GETREGW(regoff)			(*(( WORD *)(Kregs + (regoff))))
#define GETREGB(regoff)			(*(( BYTE *)(Kregs + (regoff))))

#define    SETREGQ(regoff, value)    (*((QWORD *)(Kregs + (regoff))) = (QWORD)(value))
#define	SETREGD(regoff, value)	(*((DWORD *)(Kregs + (regoff))) = (DWORD)(value))
#define	SETREGW(regoff, value)	(*(( WORD *)(Kregs + (regoff))) = ( WORD)(value))
#define SETREGB(regoff, value)	(*(( BYTE *)(Kregs + (regoff))) = ( BYTE)(value))

#define GETMEMQ(addr)           (*((QWORD *)(addr)))
#define	GETMEMD(addr)			(*((DWORD *)(addr)))
#define	GETMEMW(addr)			(*(( WORD *)(addr)))
#define	GETMEMB(addr)			(*(( BYTE *)(addr)))

#define    SETMEMQ(addr, value)    (*((QWORD *)(addr)) = (QWORD)(value))
#define	SETMEMD(addr, value)	(*((DWORD *)(addr)) = (DWORD)(value))
#define	SETMEMW(addr, value)	(*(( WORD *)(addr)) = ( WORD)(value))
#define	SETMEMB(addr, value)	(*(( BYTE *)(addr)) = ( BYTE)(value))

#define MK_LBUTT	0x0001
#define MK_RBUTT	0x0002
#define MK_SHIFT	0x0004
#define MK_CTL		0x0008
#define MK_MBUTT	0x0010
#define MK_BBUTT	0x0020
#define MK_FBUTT	0x0040
#define MK_ALT		0x8000

#define K_LBUTT		0x01
#define K_RBUTT		0x02
#define K_MBUTT		0x04

#define K_BACK		0x08
#define K_TAB		0x09
#define	K_CLEAR		0x0C
#define K_ENTER		0x0D

#define K_SHIFT		0x10
#define K_CTL		0x11
#define K_MENU		0x12
//#define	K_PAUSE	0x13
//#define	K_CAPITAL	0x14

#define K_ESC		0x1B

#define K_SPACE		0x20
#define K_PGUP		0x21
#define K_PGDN		0x22
#define K_END		0x23
#define K_HOME		0x24
#define K_LFCURS	0x25
#define K_UPCURS	0x26
#define K_RTCURS	0x27
#define K_DNCURS	0x28
//#define	K_SELECT	0x29
//#define	K_PRINT		0x2A
//#define	K_EXECUTE	0x2B
//#define	K_SNAPSHOT	0x2C
#define K_INS		0x2D
#define K_DEL		0x2E
//#define	K_HELP	0x2F

// These are just their ASCII values (uppercase for letters)
// 0-9 are 0x30 - 0x39
// A-Z are 0x41 - 0x5A
#define	K_0			0x30
#define	K_1			0x31
#define	K_2			0x32
#define	K_3			0x33
#define	K_4			0x34
#define	K_5			0x35
#define	K_6			0x36
#define	K_7			0x37
#define	K_8			0x38
#define	K_9			0x39

#define K_A			0x41
#define K_B			0x42
#define K_C			0x43
#define K_D			0x44
#define K_E			0x45
#define K_F			0x46
#define K_G			0x47
#define K_H			0x48
#define K_I			0x49
#define K_J			0x4A
#define K_K			0x4B
#define K_L			0x4C
#define K_M			0x4D
#define K_N			0x4E
#define K_O			0x4F
#define K_P			0x50
#define K_Q			0x51
#define K_R			0x52
#define K_S			0x53
#define K_T			0x54
#define K_U			0x55
#define K_V			0x56
#define K_W			0x57
#define K_X			0x58
#define	K_Y			0x59
#define	K_Z			0x5A

#define	K_LWIN			0x5B
#define	K_RWIN			0x5C
#define	K_APPS			0x5D

#define K_NUMPAD0	0x60
#define K_NUMPAD1	0x61
#define K_NUMPAD2	0x62
#define K_NUMPAD3	0x63
#define K_NUMPAD4	0x64
#define K_NUMPAD5	0x65
#define K_NUMPAD6	0x66
#define K_NUMPAD7	0x67
#define K_NUMPAD8	0x68
#define K_NUMPAD9	0x69
#define K_MULTIPLY	0x6A
#define K_NUMPADADD	0x6B
#define K_SEPARATOR	0x6C
#define K_NUMPADSUB	0x6D
#define K_DECIMAL	0x6E
#define K_NUMPADDIV	0x6F
#define K_F1		0x70
#define K_F2		0x71
#define K_F3		0x72
#define K_F4		0x73
#define K_F5		0x74
#define K_F6		0x75
#define K_F7		0x76
#define K_F8		0x77
#define K_F9		0x78
#define K_F10		0x79
#define K_F11		0x7A
#define K_F12		0x7B
#define K_F13		0x7C
#define K_F14		0x7D
#define K_F15		0x7E
#define K_F16		0x7F
#define K_F17		0x80
#define K_F18		0x81
#define K_F19		0x82
#define K_F20		0x83
#define K_F21		0x84
#define K_F22		0x85
#define K_F23		0x86
#define K_F24		0x87

#define K_NUMLOCK	0x90
#define K_SCROLL	0x91

#define	K_SEMICOLON		0xBA	// ;: key
#define K_EQPLUS		0xBB	// =+ key
#define	K_COMMA			0xBC	// ,<
#define K_UNDERSUB		0xBD	// -_ key
#define	K_PERIOD		0xBE	// .>
#define K_SLASH			0xBF	// /? key
#define	K_TILDE			0xC0	// `~
#define	K_BACKSLASH		0xDC	// \  key
#define	K_OPENBRACKET	0xDB	// [{
#define	K_BACKSLASH		0xDC	// \|
#define	K_CLOSEBRACKET	0xDD	// ]}

#define K_BACKBUTT  0x8001	// mouse BACK button
#define K_FWDBUTT   0x8002	// mouse FWD button
#define K_WHEEL		0x8003	// mouse wheel
#define	K_HWHEEL	0x8004	// mouse horizontal wheel


//**********************************************
//* "cmd" (event) offsets into a .KE file header
//**********************************************
#define	KHDR_NULLPTR			0
#define	KHDR_MAJOR_INTERP_REV	6
#define	KHDR_MINOR_INTERP_REV	7
#define	KHDR_CODE_SIZE			8
#define	KHDR_ZERODATA_SIZE		12
#define	KHDR_STACK_SIZE			16
#define	KHDR_UNUSED1			20
#define	KHDR_UNUSED2			24
#define	KHDR_UNUSED3			28
#define	KHDR_UNUSED4			32
#define	KHDR_UNUSED5			36
#define	KHDR_UNUSED6			40
#define	KHDR_UNUSED7			44
#define	KHDR_UNUSED8			48
#define	KHDR_UNUSED9			52
#define	KHDR_UNUSED10			56
#define	KHDR_SCREEN_CHANGE		60
#define	KHDR_ALPHAKEY_DOWN		64
#define	KHDR_ALPHAKEY_UP		68
#define	KHDR_BEGIN_STARTUP		72
#define	KHDR_END_STARTUP		76
#define	KHDR_WINDOW_HIDDEN		80
#define	KHDR_WINDOW_MOVE		84
#define	KHDR_WINDOW_SIZE		88
#define	KHDR_POINTER_MOVE		92
#define	KHDR_KEY_DOWN			96
#define	KHDR_KEY_UP				100
#define	KHDR_CHAR				104
#define	KHDR_TIMER				108
#define	KHDR_IDLE				112
#define	KHDR_MUSIC_DONE			116
#define	KHDR_QUERY_QUIT			120
#define	KHDR_SHUT_DOWN			124

//*************************************
//* offsets in REGISTER BYTE array for
//* each numbered register.
//*************************************
#define	REG_0	0
#define	REG_1	4
#define	REG_2	8
#define	REG_3	12
#define	REG_4	16
#define	REG_5	20
#define	REG_6	24
#define	REG_7	28
#define	REG_8	32
#define	REG_9	36
#define	REG_10	40
#define	REG_11	44
#define	REG_12	48
#define	REG_13	52
#define	REG_14	56
#define	REG_15	60
#define	REG_16	64
#define	REG_17	68
#define	REG_18	72
#define	REG_19	76
#define	REG_20	80
#define	REG_21	84
#define	REG_22	88
#define	REG_23	92
#define	REG_24	96
#define	REG_25	100
#define	REG_26	104
#define	REG_27	108
#define	REG_28	112
#define	REG_29	116
#define	REG_30	120
#define	REG_31	124
#define	REG_32	128
#define	REG_33	130
#define	REG_34	132
#define	REG_35	134
#define	REG_36	136
#define	REG_37	138
#define	REG_38	140
#define	REG_39	142
#define	REG_40	144
#define	REG_41	146
#define	REG_42	148
#define	REG_43	150
#define	REG_44	152
#define	REG_45	154
#define	REG_46	156
#define	REG_47	158
#define	REG_48	160
#define	REG_49	162
#define	REG_50	164
#define	REG_51	166
#define	REG_52	168
#define	REG_53	170
#define	REG_54	172
#define	REG_55	174
#define	REG_56	176
#define	REG_57	178
#define	REG_58	180
#define	REG_59	182
#define	REG_60	184
#define	REG_61	186
#define	REG_62	188
#define	REG_63	190
#define	REG_64	192
#define	REG_65	194
#define	REG_66	196
#define	REG_67	198
#define	REG_68	200
#define	REG_69	202
#define	REG_70	204
#define	REG_71	206
#define	REG_72	208
#define	REG_73	210
#define	REG_74	212
#define	REG_75	214
#define	REG_76	216
#define	REG_77	218
#define	REG_78	220
#define	REG_79	222
#define	REG_80	224
#define	REG_81	225
#define	REG_82	226
#define	REG_83	227
#define	REG_84	228
#define	REG_85	229
#define	REG_86	230
#define	REG_87	231
#define	REG_88	232
#define	REG_89	233
#define	REG_90	234
#define	REG_91	235
#define	REG_92	236
#define	REG_93	237
#define	REG_94	238
#define	REG_95	239
#define	REG_96	240
#define	REG_97	241
#define	REG_98	242
#define	REG_99	243
#define	REG_100	244
#define	REG_101	245
#define	REG_102	246
#define	REG_103	247
#define	REG_104	248
#define	REG_105	249
#define	REG_106	250
#define	REG_107	251
#define	REG_108	252
#define	REG_109	253
#define	REG_110	254
#define	REG_111	255

//********************************
//* SysFunc sub-function numbers *
//********************************
#define	SYS_FILESIZE	0x00
#define	SYS_FOPEN		0x01
#define	SYS_FEOF		0x02
#define	SYS_FREAD		0x03
#define	SYS_FWRITE		0x04
#define	SYS_FSEEK		0x05
#define	SYS_FCLOSE		0x06
#define	SYS_FFINDFIRST	0x07
#define	SYS_FFINDNEXT	0x08
#define	SYS_FFINDCLOSE	0x09
#define	SYS_DELETE		0x0A
#define	SYS_MAKESHARECOPY	0x0B
#define	SYS_PRINTSTART	0x0C
#define	SYS_PRINTBEGPAGE 0x0D
#define	SYS_PRINTENDPAGE 0x0E
#define	SYS_PRINTSTOP	0x0F

#define	SYS_ALLOCMEM	0x10
#define	SYS_FREEMEM		0x11
#define	SYS_TIMEREG		0x12
#define	SYS_TIMERSTR	0x13
#define	SYS_TIMEMILLI	0x14
#define	SYS_STRCAT		0x15
#define	SYS_MEMCPY		0x16
#define	SYS_MEMMOVE		0x17
#define	SYS_STRCPY		0x18
#define	SYS_STRCMP		0x19
#define	SYS_STRICMP		0x1A
#define	SYS_STRLEN		0x1B
#define	SYS_MEMSET		0x1C
#define	SYS_MEMCMP		0x1D
#define	SYS_SETCURSOR	0x1E
#define	SYS_SETPGMTITLE	0x1F

#define	SYS_CREBM		0x20
#define	SYS_DELBM		0x21
#define	SYS_ALPHABLEND	0x22
#if BETA
#define	SYS_SIZEBM		0x28
#define	SYS_DRAWBM		0x27
#define	SYS_STRETCHBM	0x26
#define	SYS_DRAWMBM		0x25
#define	SYS_LOADBM		0x24
#define	SYS_LOADMBM		0x23
#else
#define	SYS_SIZEBM		0x23
#define	SYS_DRAWBM		0x24
#define	SYS_STRETCHBM	0x25
#define	SYS_DRAWMBM		0x26
#define	SYS_LOADBM		0x27
#define	SYS_LOADMBM		0x28
#endif
#define	SYS_STRETCHMBM	0x29	// NOTE: This opcode was added at REV 2.0 of KINT

#define SYS_GETWINDOWPOS 0x2A
#define	SYS_SETWINDOWPOS 0x2B
#define	SYS_GETVIEWSIZE 0x2C
#define	SYS_ORIENTBM	0x2D
#define	SYS_GETSCREENSIZE 0x2E
#define	SYS_FLUSHSCREEN	0x2F

#define	SYS_RECTEDGED	0x30
#define	SYS_RECTSOLID	0x31
#define	SYS_RECTOUTLINE	0x32
#define	SYS_LINES		0x33
#define	SYS_SETPIXEL	0x34
#define	SYS_GETPIXEL	0x35
#define	SYS_COLORIZE	0x36
#define	SYS_RECT		0x37
#define	SYS_OVAL		0x38
#define	SYS_GETTEXTSIZE	0x39
#define	SYS_GETFONT		0x3A
#define	SYS_RELFONT		0x3B
#define	SYS_BEGTEXT		0x3C
#define	SYS_TEXTSTYLE	0x3D
#define	SYS_TEXT		0x3E
#define	SYS_ENDTEXT		0x3F

#define	SYS_PLAYSOUND	0x40
#define	SYS_PLAYMUSIC	0x41
#define	SYS_STOPMUSIC	0x42
#define	SYS_ISMUSIC		0x43
#define	SYS_CAPTUREMOUSE 0x44
#define	SYS_MEMSET2		0x45
#define	SYS_MEMSET4		0x46
#define	SYS_PRINTFONT	0x47
#define	SYS_STARTTIMER	0x48
#define	SYS_STOPTIMER	0x49
#define	SYS_GETEOL		0x4A
#define	SYS_PRINTGETTEXTSIZE 0x4B
#define	SYS_PRINTTEXT	0x4C
#define	SYS_PRINTBM		0x4D
#define	SYS_PRINTLINES	0x4E
#define	SYS_SYSTEMMSG	0x4F

#define	SYS_LOADKE		0x50
#define	SYS_UNLOADKE	0x51
#define	SYS_MSGKE		0x52

#define	SYS_LOADLOSSYBM	0x54
#define	SYS_INVDRAWBM	0x55
#define	SYS_INVDRAWMBM	0x56
#define	SYS_LINESTYLE	0x57
#define	SYS_MAKEFOLDER	0x58
#define	SYS_DELFOLDER	0x59
#define	SYS_CLIP		0x5A
#define	SYS_GETCLIP		0x5B
#define	SYS_MASKBM		0x5C
#define	SYS_RGB2HSL		0x5D
#define	SYS_HSL2RGB		0x5E
#define	SYS_SAVEBM		0x5F

#define	SYS_PRINTRECT	0x60
#define	SYS_SLEEP		0x61
#define	SYS_GETSYSTEMDATA 0x62
#define	SYS_MEMSET200	0x63
#define	SYS_MEMSET400	0x64
#define	SYS_STRCAT00	0x65
#define	SYS_MEMCPY00	0x66
#define	SYS_MEMMOVE00	0x67
#define	SYS_STRCPY00	0x68
#define	SYS_STRCMP00	0x69
#define	SYS_STRICMP00	0x6A
#define	SYS_STRLEN00	0x6B
#define	SYS_MEMSET00	0x6C
#define	SYS_MEMCMP00	0x6D

//*****************************
//* function prototypes
//*****************************
int LoadKEFile(void);
WORD KEmsg(KE *pKE, WORD cmd, DWORD arg1, DWORD arg2, DWORD arg3);
WORD ExecKE(KE *pKE);
void SysFunc(KE *pKE, WORD opcode);
void SysStartup(void);
void SysCleanup(void);
void SysExit(void);
void SysMinimize(Boolean isMin);

// graphic function prototypes
WORD FitFont(BYTE *text, WORD w, WORD h, WORD fixedpitch);

// The following are the KASM/KINT file-open flag definitions.
// These are consistent with standard C library #define values
// but if this is being translated to another language, it's
// good to know what the KASM code is going to be passing you and
// what it means....
#define	O_RDBIN		0x8000	// read only, binary
#define	O_WRBIN		0x8002	// read/write, binary
#define	O_WRBINNEW	0x8302	// read/write, binary, create or truncate

// The following are the KASM/KINT file-open directories
#define	DIR_GAME		0
#define	DIR_UI			1
#define DIR_IMAGES		2
#define DIR_BACKGNDS	3
#define DIR_MUSIC		4
#define DIR_SOUNDS		5
#define	DIR_GAME_IMG	6
#define	DIR_UI_COMMON	7
#define	DIR_LOSSY		0x40
#define	DIR_NOEXT		0x80

void InitScreen(long minW, long minH);
void KillProgram(void);
void KPlaySound(char *pMem);
void SystemMessage(char *pMem);
char *GetFileName(char *fname, char *xname);
void BuildPath(char *fname, BYTE folder, BOOL AppData);

DWORD Kopen(char *fname, KLONG oflags, Boolean resource);
DWORD Kseek(DWORD fhandle, DWORD foffset, KLONG origin);
void Kclose(DWORD fhandle);
DWORD Kstat(char *fname, BYTE dir, DWORD *modtim, BYTE *filtyp);
DWORD Keof(DWORD fhandle);
DWORD Kread(DWORD fhandle, BYTE *pMem, DWORD numbytes);
DWORD Kwrite(DWORD fhandle, BYTE *pMem, DWORD numbytes);

void KGetTime(KTIME *pT);
void KTimeToString(BYTE *pMem);
DWORD KGetTicks(void);

void InvalidateScreen(KLONG x1, KLONG y1, KLONG x2, KLONG y2);
void FlushScreen(void);

void KSleep(DWORD tmilli);
void KGetOSversion(BYTE *pMem);
DWORD CreateBM(KLONG w, KLONG h);
void DeleteBM(DWORD index);
void CreateBM0(void);
void Rectangle(DWORD hBM, CGRect rect, DWORD fillclr, DWORD edgeclr);
void Lines(DWORD hBM, CGPoint *points, size_t numpoints, CGColorRef clr);
void LinesCTX(CGContextRef ctx, CGPoint *points, size_t numpoints, CGColorRef clr);
Boolean setIntersect(CGRect *modRect, CGRect *rect2);
void AddMsg(WORD cmd, DWORD arg1, DWORD arg2, DWORD arg3);
KLONG Kfilesize(char *fn, DWORD *timmod);
DWORD LoadBM(BYTE *fname, DWORD fnameIndex);
void StretchBM(DWORD tarBM, KLONG tarX, KLONG tarY, KLONG tarW, KLONG tarH, DWORD srcBM, KLONG srcX, KLONG srcY, KLONG srcW, KLONG srcH);
void OvalRect(DWORD hBM, KLONG x1, KLONG y1, KLONG x2, KLONG y2, KLONG fill, KLONG edge, KLONG round);
void TextBM(DWORD hBM, KLONG x, KLONG y, char *str);
WORD FitFont(BYTE *text, WORD w, WORD h, WORD flags);
void RelFont(KLONG w);
void SetTextStyle(KLONG font, DWORD textClr, DWORD backClr);
extern KLONG	kRotated;
void TestRect(DWORD hBM, CGRect rect, DWORD fill, DWORD edge);
void SendNextMsg(void);
BOOL KeyMsg(DWORD *cmd, DWORD *arg1, DWORD *arg2, DWORD *arg3);

NSFont *FitSysFont(NSString *text, int w, int h, WORD flags, CGSize *fontsize);
void InitSysFonts(int w, int h);
void FreeSysFonts(void);
DWORD DrawSysFontText(PBMB pBM, char *pText, int x, int y, int w, int h, int flags, DWORD bclr, DWORD fclr, long *pW);
void PurgeMsgs(void);

extern bool inKE;
extern KLONG	dirtyX1, dirtyY1, dirtyX2, dirtyY2;
extern NSTimer *KINTmsgTimer;
extern KLONG		PhysicalScreenW, PhysicalScreenH, PhysicalScreenSizeIndex;


/// SysFont FLAGS
#define	ST_FIXED		1
#define	ST_BOLD			2
#define	ST_ITALIC		4
#define	ST_UNDERLINED	8
#define	ST_SERIF		16
#define	ST_CENTER		32
#define	ST_RIGHT		64
#define	ST_ROTATE		128
#define	ST_BRK_CHAR		256
#define	ST_BRK_SPACE	512
#define	ST_CALC_LEN		32768

#define	ST_FONT_CHARS	(ST_FIXED | ST_BOLD | ST_ITALIC | ST_UNDERLINED | ST_SERIF)

//******************************
/// NOTE: It's CRITICAL that the following typedefs all result in 4-byte data types. Change as necessary when compiling on a new platform to ensure this!!!!
typedef Float32            KFf4;
typedef int32_t            KFs4;
typedef uint32_t    KFu4;
/// NOTE: It's CRITICAL that the following typedef results in 8-byte data type. Change as necessary when compiling on a new platform to ensure this!!!
typedef int64_t        KFs8;


KFf4 KFadd(KFf4 a, KFf4 b);
KFf4 KFsub(KFf4 a, KFf4 b);
KFf4 KFmul(KFf4 a, KFf4 b);
KFf4 KFdiv(KFf4 a, KFf4 b);
KFf4 KFneg(KFf4 a);
KFf4 KFsqr(KFf4 a);
